/* Server.c generated by valac 0.56.17, the Vala compiler
 * generated from Server.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <polkit/polkit.h>
#include <glib/gstdio.h>

#define PC_DAEMON_SERVER_CLIENT_LAUNCH_TIMEOUT ((guint) 5000)
#define PC_CONSTANTS_PARENTAL_CONTROLS_ACTION_ID "io.elementary.settings.screentime-limits.administration"
#define PC_ACCESS_CONTROL_LISTS_NO_EXEC_PERMISSIONS "---"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PC_DAEMON_TYPE_DBUS (pc_daemon_dbus_get_type ())
#define PC_DAEMON_DBUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_DBUS, PCDaemonDBus))
#define PC_DAEMON_IS_DBUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_DBUS))
#define PC_DAEMON_DBUS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PC_DAEMON_TYPE_DBUS, PCDaemonDBusIface))

typedef struct _PCDaemonDBus PCDaemonDBus;
typedef struct _PCDaemonDBusIface PCDaemonDBusIface;

#define PC_DAEMON_TYPE_DBUS_PROXY (pc_daemon_dbus_proxy_get_type ())
typedef GDBusProxy PCDaemonDBusProxy;
typedef GDBusProxyClass PCDaemonDBusProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define PC_DAEMON_TYPE_PARENTAL_CONTROLS_ERROR (pc_daemon_parental_controls_error_get_type ())

#define PC_DAEMON_TYPE_SERVER (pc_daemon_server_get_type ())
#define PC_DAEMON_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_SERVER, PCDaemonServer))
#define PC_DAEMON_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_SERVER, PCDaemonServerClass))
#define PC_DAEMON_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_SERVER))
#define PC_DAEMON_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_SERVER))
#define PC_DAEMON_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_SERVER, PCDaemonServerClass))

typedef struct _PCDaemonServer PCDaemonServer;
typedef struct _PCDaemonServerClass PCDaemonServerClass;
typedef struct _PCDaemonServerPrivate PCDaemonServerPrivate;
enum  {
	PC_DAEMON_SERVER_0_PROPERTY,
	PC_DAEMON_SERVER_NUM_PROPERTIES
};
static GParamSpec* pc_daemon_server_properties[PC_DAEMON_SERVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;

#define PC_DAEMON_TYPE_USER_CONFIG (pc_daemon_user_config_get_type ())
#define PC_DAEMON_USER_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfig))
#define PC_DAEMON_USER_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfigClass))
#define PC_DAEMON_IS_USER_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_USER_CONFIG))
#define PC_DAEMON_IS_USER_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_USER_CONFIG))
#define PC_DAEMON_USER_CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfigClass))

typedef struct _PCDaemonUserConfig PCDaemonUserConfig;
typedef struct _PCDaemonUserConfigClass PCDaemonUserConfigClass;
typedef struct _Block3Data Block3Data;

#define PC_PAM_TYPE_WRITER (pc_pam_writer_get_type ())
#define PC_PAM_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_PAM_TYPE_WRITER, PCPAMWriter))
#define PC_PAM_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_PAM_TYPE_WRITER, PCPAMWriterClass))
#define PC_PAM_IS_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_PAM_TYPE_WRITER))
#define PC_PAM_IS_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_PAM_TYPE_WRITER))
#define PC_PAM_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_PAM_TYPE_WRITER, PCPAMWriterClass))

typedef struct _PCPAMWriter PCPAMWriter;
typedef struct _PCPAMWriterClass PCPAMWriterClass;

#define PC_DAEMON_TYPE_SESSION_HANDLER (pc_daemon_session_handler_get_type ())
#define PC_DAEMON_SESSION_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_SESSION_HANDLER, PCDaemonSessionHandler))
#define PC_DAEMON_SESSION_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_SESSION_HANDLER, PCDaemonSessionHandlerClass))
#define PC_DAEMON_IS_SESSION_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_SESSION_HANDLER))
#define PC_DAEMON_IS_SESSION_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_SESSION_HANDLER))
#define PC_DAEMON_SESSION_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_SESSION_HANDLER, PCDaemonSessionHandlerClass))

typedef struct _PCDaemonSessionHandler PCDaemonSessionHandler;
typedef struct _PCDaemonSessionHandlerClass PCDaemonSessionHandlerClass;

#define PC_DAEMON_TYPE_SESSION_MANAGER (pc_daemon_session_manager_get_type ())
#define PC_DAEMON_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_SESSION_MANAGER, PCDaemonSessionManager))
#define PC_DAEMON_SESSION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_SESSION_MANAGER, PCDaemonSessionManagerClass))
#define PC_DAEMON_IS_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_SESSION_MANAGER))
#define PC_DAEMON_IS_SESSION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_SESSION_MANAGER))
#define PC_DAEMON_SESSION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_SESSION_MANAGER, PCDaemonSessionManagerClass))

typedef struct _PCDaemonSessionManager PCDaemonSessionManager;
typedef struct _PCDaemonSessionManagerClass PCDaemonSessionManagerClass;
typedef struct _PCDaemonSessionManagerPrivate PCDaemonSessionManagerPrivate;
enum  {
	PC_DAEMON_SERVER_LAUNCH_SIGNAL,
	PC_DAEMON_SERVER_SHOW_TIMEOUT_SIGNAL,
	PC_DAEMON_SERVER_CONFIG_CHANGED_SIGNAL,
	PC_DAEMON_SERVER_NUM_SIGNALS
};
static guint pc_daemon_server_signals[PC_DAEMON_SERVER_NUM_SIGNALS] = {0};

struct _PCDaemonDBusIface {
	GTypeInterface parent_iface;
	guint32 (*get_connection_unix_process_id) (PCDaemonDBus* self, const gchar* name, GError** error);
	guint32 (*get_connection_unix_user) (PCDaemonDBus* self, const gchar* name, GError** error);
};

typedef enum  {
	PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED,
	PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_IMPLEMENTED,
	PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD,
	PC_DAEMON_PARENTAL_CONTROLS_ERROR_DBUS_CONNECTION_FAILED
} PCDaemonParentalControlsError;
#define PC_DAEMON_PARENTAL_CONTROLS_ERROR pc_daemon_parental_controls_error_quark ()

struct _PCDaemonServer {
	GObject parent_instance;
	PCDaemonServerPrivate * priv;
};

struct _PCDaemonServerClass {
	GObjectClass parent_class;
};

struct _PCDaemonServerPrivate {
	PCDaemonDBus* bus_proxy;
};

struct _Block2Data {
	int _ref_count_;
	PCDaemonServer* self;
	gchar* username;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	gchar* path;
	gulong launch_signal_id;
	guint timeout_signal_id;
};

struct _PCDaemonSessionManager {
	GObject parent_instance;
	PCDaemonSessionManagerPrivate * priv;
	PCDaemonSessionHandler* current_handler;
};

struct _PCDaemonSessionManagerClass {
	GObjectClass parent_class;
};

static gint PCDaemonServer_private_offset;
static gpointer pc_daemon_server_parent_class = NULL;
static PCDaemonServer* pc_daemon_server_instance;
static PCDaemonServer* pc_daemon_server_instance = NULL;

VALA_EXTERN GType pc_daemon_dbus_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint pc_daemon_dbus_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
VALA_EXTERN GType pc_daemon_dbus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonDBus, g_object_unref)
VALA_EXTERN guint32 pc_daemon_dbus_get_connection_unix_process_id (PCDaemonDBus* self,
                                                       const gchar* name,
                                                       GError** error);
VALA_EXTERN guint32 pc_daemon_dbus_get_connection_unix_user (PCDaemonDBus* self,
                                                 const gchar* name,
                                                 GError** error);
static GType pc_daemon_dbus_get_type_once (void);
static void pc_daemon_dbus_proxy_g_signal (GDBusProxy* proxy,
                                    const gchar* sender_name,
                                    const gchar* signal_name,
                                    GVariant* parameters);
static guint32 pc_daemon_dbus_proxy_get_connection_unix_process_id (PCDaemonDBus* self,
                                                             const gchar* name,
                                                             GError** error);
static guint32 pc_daemon_dbus_proxy_get_connection_unix_user (PCDaemonDBus* self,
                                                       const gchar* name,
                                                       GError** error);
static void pc_daemon_dbus_proxy_pc_daemon_dbus_interface_init (PCDaemonDBusIface* iface);
static void _dbus_pc_daemon_dbus_get_connection_unix_process_id (PCDaemonDBus* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_dbus_get_connection_unix_user (PCDaemonDBus* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void pc_daemon_dbus_dbus_interface_method_call (GDBusConnection* connection,
                                                const gchar* sender,
                                                const gchar* object_path,
                                                const gchar* interface_name,
                                                const gchar* method_name,
                                                GVariant* parameters,
                                                GDBusMethodInvocation* invocation,
                                                gpointer user_data);
static GVariant* pc_daemon_dbus_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data);
static gboolean pc_daemon_dbus_dbus_interface_set_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GVariant* value,
                                                     GError** error,
                                                     gpointer user_data);
static void _pc_daemon_dbus_unregister_object (gpointer user_data);
VALA_EXTERN GQuark pc_daemon_parental_controls_error_quark (void);
VALA_EXTERN GType pc_daemon_parental_controls_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType pc_daemon_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonServer, g_object_unref)
VALA_EXTERN guint pc_daemon_server_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
VALA_EXTERN PCDaemonServer* pc_daemon_server_get_default (void);
VALA_EXTERN PCDaemonServer* pc_daemon_server_new (void);
VALA_EXTERN PCDaemonServer* pc_daemon_server_construct (GType object_type);
VALA_EXTERN void pc_daemon_user_config_init (void);
static void pc_daemon_server_on_config_changed (PCDaemonServer* self);
static void _pc_daemon_server_on_config_changed_pc_daemon_server_config_changed (PCDaemonServer* _sender,
                                                                          gpointer self);
VALA_EXTERN void pc_daemon_server_finish_app_authorization (PCDaemonServer* self,
                                                const char* sender,
                                                const gchar* username,
                                                gchar** args,
                                                gint args_length1,
                                                GError** error);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN GType pc_daemon_user_config_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonUserConfig, g_object_unref)
VALA_EXTERN PCDaemonUserConfig* pc_daemon_user_config_get_for_username (const gchar* username,
                                                            gboolean create);
VALA_EXTERN gboolean pc_daemon_user_config_get_admin (PCDaemonUserConfig* self);
static guint32 pc_daemon_server_get_pid_from_sender (PCDaemonServer* self,
                                              const char* sender);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN void pc_access_control_lists_setfacl (const gchar* username,
                                      const gchar* target,
                                      const gchar* permissions_str);
static void ____lambda12_ (Block3Data* _data3_,
                    gchar** args,
                    gint args_length1,
                    gboolean incoming);
static void _____lambda12__pc_daemon_server_launch (PCDaemonServer* _sender,
                                             gchar** args,
                                             gint args_length1,
                                             gboolean incoming,
                                             gpointer self);
static gboolean ____lambda13_ (Block3Data* _data3_);
static gboolean _____lambda13__gsource_func (gpointer self);
VALA_EXTERN void pc_daemon_server_add_restriction_for_user (PCDaemonServer* self,
                                                const gchar* input,
                                                gboolean clean,
                                                const char* sender,
                                                GError** error);
static gboolean pc_daemon_server_get_sender_is_authorized (PCDaemonServer* self,
                                                    const char* sender,
                                                    GError** error);
static void pc_daemon_server_ensure_pam_lightdm_enabled (PCDaemonServer* self);
VALA_EXTERN GType pc_pam_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCPAMWriter, g_object_unref)
VALA_EXTERN PCPAMWriter* pc_pam_writer_new_for_time (void);
VALA_EXTERN void pc_pam_writer_add_restriction_for_user (PCPAMWriter* self,
                                             const gchar* input,
                                             gboolean clean);
VALA_EXTERN void pc_daemon_server_remove_restriction_for_user (PCDaemonServer* self,
                                                   const gchar* username,
                                                   const char* sender,
                                                   GError** error);
VALA_EXTERN void pc_pam_writer_remove_restriction_for_user (PCPAMWriter* self,
                                                const gchar* username);
VALA_EXTERN void pc_daemon_server_lock_dock_icons_for_user (PCDaemonServer* self,
                                                const gchar* username,
                                                gboolean lock,
                                                const char* sender,
                                                GError** error);
VALA_EXTERN void pc_daemon_server_set_user_daemon_active (PCDaemonServer* self,
                                              const gchar* username,
                                              gboolean active,
                                              const char* sender,
                                              GError** error);
VALA_EXTERN void pc_daemon_user_config_set_active (PCDaemonUserConfig* self,
                                       gboolean value);
VALA_EXTERN void pc_daemon_server_set_user_daemon_targets (PCDaemonServer* self,
                                               const gchar* username,
                                               gchar** targets,
                                               gint targets_length1,
                                               const char* sender,
                                               GError** error);
VALA_EXTERN void pc_daemon_user_config_set_targets (PCDaemonUserConfig* self,
                                        gchar** value,
                                        gint value_length1);
VALA_EXTERN void pc_daemon_server_set_user_daemon_block_urls (PCDaemonServer* self,
                                                  const gchar* username,
                                                  gchar** block_urls,
                                                  gint block_urls_length1,
                                                  const char* sender,
                                                  GError** error);
VALA_EXTERN void pc_daemon_user_config_set_block_urls (PCDaemonUserConfig* self,
                                           gchar** value,
                                           gint value_length1);
VALA_EXTERN void pc_daemon_server_set_user_daemon_admin (PCDaemonServer* self,
                                             const gchar* username,
                                             gboolean admin,
                                             const char* sender,
                                             GError** error);
VALA_EXTERN void pc_daemon_user_config_set_admin (PCDaemonUserConfig* self,
                                      gboolean value);
VALA_EXTERN gboolean pc_daemon_server_get_user_daemon_active (PCDaemonServer* self,
                                                  const gchar* username,
                                                  GError** error);
VALA_EXTERN gboolean pc_daemon_user_config_get_active (PCDaemonUserConfig* self);
VALA_EXTERN gchar** pc_daemon_server_get_user_daemon_targets (PCDaemonServer* self,
                                                  const gchar* username,
                                                  gint* result_length1,
                                                  GError** error);
VALA_EXTERN gchar** pc_daemon_user_config_get_targets (PCDaemonUserConfig* self,
                                           gint* result_length1);
VALA_EXTERN gchar** pc_daemon_server_get_user_daemon_block_urls (PCDaemonServer* self,
                                                     const gchar* username,
                                                     gint* result_length1,
                                                     GError** error);
VALA_EXTERN gchar** pc_daemon_user_config_get_block_urls (PCDaemonUserConfig* self,
                                              gint* result_length1);
VALA_EXTERN gboolean pc_daemon_server_get_user_daemon_admin (PCDaemonServer* self,
                                                 const gchar* username,
                                                 GError** error);
VALA_EXTERN GType pc_daemon_session_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonSessionHandler, g_object_unref)
VALA_EXTERN GType pc_daemon_session_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonSessionManager, g_object_unref)
VALA_EXTERN PCDaemonSessionManager* pc_daemon_session_manager_get_default (void);
VALA_EXTERN void pc_daemon_session_handler_update (PCDaemonSessionHandler* self);
static void _vala_array_add2 (const gchar** * array,
                       gint* length,
                       gint* size,
                       const gchar* value);
static void g_cclosure_user_marshal_VOID__BOXED_INT_BOOLEAN (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void pc_daemon_server_finalize (GObject * obj);
static GType pc_daemon_server_get_type_once (void);
static void _dbus_pc_daemon_server_finish_app_authorization (PCDaemonServer* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_add_restriction_for_user (PCDaemonServer* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_remove_restriction_for_user (PCDaemonServer* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_lock_dock_icons_for_user (PCDaemonServer* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_set_user_daemon_active (PCDaemonServer* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_set_user_daemon_targets (PCDaemonServer* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_set_user_daemon_block_urls (PCDaemonServer* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_set_user_daemon_admin (PCDaemonServer* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_get_user_daemon_active (PCDaemonServer* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_get_user_daemon_targets (PCDaemonServer* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_get_user_daemon_block_urls (PCDaemonServer* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation);
static void _dbus_pc_daemon_server_get_user_daemon_admin (PCDaemonServer* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void pc_daemon_server_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data);
static GVariant* pc_daemon_server_dbus_interface_get_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GError** error,
                                                        gpointer user_data);
static gboolean pc_daemon_server_dbus_interface_set_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GVariant* value,
                                                       GError** error,
                                                       gpointer user_data);
static void _dbus_pc_daemon_server_launch (GObject* _sender,
                                    gchar** args,
                                    gint args_length1,
                                    gboolean incoming,
                                    gpointer* _data);
static void _dbus_pc_daemon_server_show_timeout (GObject* _sender,
                                          gint hours,
                                          gint minutes,
                                          gpointer* _data);
static void _dbus_pc_daemon_server_config_changed (GObject* _sender,
                                            gpointer* _data);
static void _pc_daemon_server_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_in[] = {&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_name, NULL};
static const GDBusArgInfo * const _pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_out[] = {&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_result, NULL};
static const GDBusMethodInfo _pc_daemon_dbus_dbus_method_info_get_connection_unix_process_id = {-1, "GetConnectionUnixProcessID", (GDBusArgInfo **) (&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_in), (GDBusArgInfo **) (&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_process_id_out), NULL};
static const GDBusArgInfo _pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_name = {-1, "name", "s", NULL};
static const GDBusArgInfo _pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_in[] = {&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_name, NULL};
static const GDBusArgInfo * const _pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_out[] = {&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_result, NULL};
static const GDBusMethodInfo _pc_daemon_dbus_dbus_method_info_get_connection_unix_user = {-1, "GetConnectionUnixUser", (GDBusArgInfo **) (&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_in), (GDBusArgInfo **) (&_pc_daemon_dbus_dbus_arg_info_get_connection_unix_user_out), NULL};
static const GDBusMethodInfo * const _pc_daemon_dbus_dbus_method_info[] = {&_pc_daemon_dbus_dbus_method_info_get_connection_unix_process_id, &_pc_daemon_dbus_dbus_method_info_get_connection_unix_user, NULL};
static const GDBusSignalInfo * const _pc_daemon_dbus_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _pc_daemon_dbus_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _pc_daemon_dbus_dbus_interface_info = {-1, "org.freedesktop.DBus", (GDBusMethodInfo **) (&_pc_daemon_dbus_dbus_method_info), (GDBusSignalInfo **) (&_pc_daemon_dbus_dbus_signal_info), (GDBusPropertyInfo **) (&_pc_daemon_dbus_dbus_property_info), NULL};
static const GDBusInterfaceVTable _pc_daemon_dbus_dbus_interface_vtable = {pc_daemon_dbus_dbus_interface_method_call, pc_daemon_dbus_dbus_interface_get_property, pc_daemon_dbus_dbus_interface_set_property};
static const GDBusErrorEntry pc_daemon_parental_controls_error_entries[] = {{PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "org.pantheon.ParentalControls.NotAuthorized"}, {PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_IMPLEMENTED, "org.pantheon.ParentalControls.NotImplemented"}, {PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "org.pantheon.ParentalControls.UserConfigNotVaild"}, {PC_DAEMON_PARENTAL_CONTROLS_ERROR_DBUS_CONNECTION_FAILED, "org.pantheon.ParentalControls.DbusConnectionFailed"}};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_finish_app_authorization_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_finish_app_authorization_args = {-1, "args", "as", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_finish_app_authorization_in[] = {&_pc_daemon_server_dbus_arg_info_finish_app_authorization_username, &_pc_daemon_server_dbus_arg_info_finish_app_authorization_args, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_finish_app_authorization_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_finish_app_authorization = {-1, "FinishAppAuthorization", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_finish_app_authorization_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_finish_app_authorization_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_add_restriction_for_user_input = {-1, "input", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_add_restriction_for_user_clean = {-1, "clean", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_add_restriction_for_user_in[] = {&_pc_daemon_server_dbus_arg_info_add_restriction_for_user_input, &_pc_daemon_server_dbus_arg_info_add_restriction_for_user_clean, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_add_restriction_for_user_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_add_restriction_for_user = {-1, "AddRestrictionForUser", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_add_restriction_for_user_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_add_restriction_for_user_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_remove_restriction_for_user_username = {-1, "username", "s", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_remove_restriction_for_user_in[] = {&_pc_daemon_server_dbus_arg_info_remove_restriction_for_user_username, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_remove_restriction_for_user_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_remove_restriction_for_user = {-1, "RemoveRestrictionForUser", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_remove_restriction_for_user_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_remove_restriction_for_user_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_lock = {-1, "lock", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_in[] = {&_pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_username, &_pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_lock, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_lock_dock_icons_for_user = {-1, "LockDockIconsForUser", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_lock_dock_icons_for_user_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_active_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_active_active = {-1, "active", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_active_in[] = {&_pc_daemon_server_dbus_arg_info_set_user_daemon_active_username, &_pc_daemon_server_dbus_arg_info_set_user_daemon_active_active, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_active_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_set_user_daemon_active = {-1, "SetUserDaemonActive", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_active_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_active_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_targets_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_targets_targets = {-1, "targets", "as", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_targets_in[] = {&_pc_daemon_server_dbus_arg_info_set_user_daemon_targets_username, &_pc_daemon_server_dbus_arg_info_set_user_daemon_targets_targets, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_targets_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_set_user_daemon_targets = {-1, "SetUserDaemonTargets", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_targets_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_targets_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_block_urls = {-1, "block_urls", "as", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_in[] = {&_pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_username, &_pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_block_urls, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_set_user_daemon_block_urls = {-1, "SetUserDaemonBlockUrls", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_block_urls_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_admin_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_set_user_daemon_admin_admin = {-1, "admin", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_admin_in[] = {&_pc_daemon_server_dbus_arg_info_set_user_daemon_admin_username, &_pc_daemon_server_dbus_arg_info_set_user_daemon_admin_admin, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_set_user_daemon_admin_out[] = {NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_set_user_daemon_admin = {-1, "SetUserDaemonAdmin", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_admin_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_set_user_daemon_admin_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_active_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_active_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_active_in[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_active_username, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_active_out[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_active_result, NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_get_user_daemon_active = {-1, "GetUserDaemonActive", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_active_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_active_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_targets_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_targets_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_targets_in[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_targets_username, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_targets_out[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_targets_result, NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_get_user_daemon_targets = {-1, "GetUserDaemonTargets", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_targets_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_targets_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_result = {-1, "result", "as", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_in[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_username, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_out[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_result, NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_get_user_daemon_block_urls = {-1, "GetUserDaemonBlockUrls", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_block_urls_out), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_admin_username = {-1, "username", "s", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_get_user_daemon_admin_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_admin_in[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_admin_username, NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_get_user_daemon_admin_out[] = {&_pc_daemon_server_dbus_arg_info_get_user_daemon_admin_result, NULL};
static const GDBusMethodInfo _pc_daemon_server_dbus_method_info_get_user_daemon_admin = {-1, "GetUserDaemonAdmin", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_admin_in), (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_get_user_daemon_admin_out), NULL};
static const GDBusMethodInfo * const _pc_daemon_server_dbus_method_info[] = {&_pc_daemon_server_dbus_method_info_finish_app_authorization, &_pc_daemon_server_dbus_method_info_add_restriction_for_user, &_pc_daemon_server_dbus_method_info_remove_restriction_for_user, &_pc_daemon_server_dbus_method_info_lock_dock_icons_for_user, &_pc_daemon_server_dbus_method_info_set_user_daemon_active, &_pc_daemon_server_dbus_method_info_set_user_daemon_targets, &_pc_daemon_server_dbus_method_info_set_user_daemon_block_urls, &_pc_daemon_server_dbus_method_info_set_user_daemon_admin, &_pc_daemon_server_dbus_method_info_get_user_daemon_active, &_pc_daemon_server_dbus_method_info_get_user_daemon_targets, &_pc_daemon_server_dbus_method_info_get_user_daemon_block_urls, &_pc_daemon_server_dbus_method_info_get_user_daemon_admin, NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_launch_args = {-1, "args", "as", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_launch_incoming = {-1, "incoming", "b", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_launch[] = {&_pc_daemon_server_dbus_arg_info_launch_args, &_pc_daemon_server_dbus_arg_info_launch_incoming, NULL};
static const GDBusSignalInfo _pc_daemon_server_dbus_signal_info_launch = {-1, "Launch", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_launch), NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_show_timeout_hours = {-1, "hours", "i", NULL};
static const GDBusArgInfo _pc_daemon_server_dbus_arg_info_show_timeout_minutes = {-1, "minutes", "i", NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_show_timeout[] = {&_pc_daemon_server_dbus_arg_info_show_timeout_hours, &_pc_daemon_server_dbus_arg_info_show_timeout_minutes, NULL};
static const GDBusSignalInfo _pc_daemon_server_dbus_signal_info_show_timeout = {-1, "ShowTimeout", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_show_timeout), NULL};
static const GDBusArgInfo * const _pc_daemon_server_dbus_arg_info_config_changed[] = {NULL};
static const GDBusSignalInfo _pc_daemon_server_dbus_signal_info_config_changed = {-1, "ConfigChanged", (GDBusArgInfo **) (&_pc_daemon_server_dbus_arg_info_config_changed), NULL};
static const GDBusSignalInfo * const _pc_daemon_server_dbus_signal_info[] = {&_pc_daemon_server_dbus_signal_info_launch, &_pc_daemon_server_dbus_signal_info_show_timeout, &_pc_daemon_server_dbus_signal_info_config_changed, NULL};
static const GDBusPropertyInfo * const _pc_daemon_server_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _pc_daemon_server_dbus_interface_info = {-1, "org.pantheon.ParentalControls", (GDBusMethodInfo **) (&_pc_daemon_server_dbus_method_info), (GDBusSignalInfo **) (&_pc_daemon_server_dbus_signal_info), (GDBusPropertyInfo **) (&_pc_daemon_server_dbus_property_info), NULL};
static const GDBusInterfaceVTable _pc_daemon_server_dbus_interface_vtable = {pc_daemon_server_dbus_interface_method_call, pc_daemon_server_dbus_interface_get_property, pc_daemon_server_dbus_interface_set_property};

guint32
pc_daemon_dbus_get_connection_unix_process_id (PCDaemonDBus* self,
                                               const gchar* name,
                                               GError** error)
{
	PCDaemonDBusIface* _iface_;
#line 27 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 27 "../src/daemon/Server.vala"
	_iface_ = PC_DAEMON_DBUS_GET_INTERFACE (self);
#line 27 "../src/daemon/Server.vala"
	if (_iface_->get_connection_unix_process_id) {
#line 27 "../src/daemon/Server.vala"
		return _iface_->get_connection_unix_process_id (self, name, error);
#line 581 "Server.c"
	}
#line 27 "../src/daemon/Server.vala"
	return 0U;
#line 585 "Server.c"
}

guint32
pc_daemon_dbus_get_connection_unix_user (PCDaemonDBus* self,
                                         const gchar* name,
                                         GError** error)
{
	PCDaemonDBusIface* _iface_;
#line 28 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 28 "../src/daemon/Server.vala"
	_iface_ = PC_DAEMON_DBUS_GET_INTERFACE (self);
#line 28 "../src/daemon/Server.vala"
	if (_iface_->get_connection_unix_user) {
#line 28 "../src/daemon/Server.vala"
		return _iface_->get_connection_unix_user (self, name, error);
#line 602 "Server.c"
	}
#line 28 "../src/daemon/Server.vala"
	return 0U;
#line 606 "Server.c"
}

static void
pc_daemon_dbus_default_init (PCDaemonDBusIface * iface,
                             gpointer iface_data)
{
}

static GType
pc_daemon_dbus_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCDaemonDBusIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_daemon_dbus_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType pc_daemon_dbus_type_id;
	pc_daemon_dbus_type_id = g_type_register_static (G_TYPE_INTERFACE, "PCDaemonDBus", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (pc_daemon_dbus_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (pc_daemon_dbus_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) pc_daemon_dbus_proxy_get_type);
	g_type_set_qdata (pc_daemon_dbus_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.DBus");
	g_type_set_qdata (pc_daemon_dbus_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_pc_daemon_dbus_dbus_interface_info));
	g_type_set_qdata (pc_daemon_dbus_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) pc_daemon_dbus_register_object);
	return pc_daemon_dbus_type_id;
}

GType
pc_daemon_dbus_get_type (void)
{
	static volatile gsize pc_daemon_dbus_type_id__once = 0;
	if (g_once_init_enter (&pc_daemon_dbus_type_id__once)) {
		GType pc_daemon_dbus_type_id;
		pc_daemon_dbus_type_id = pc_daemon_dbus_get_type_once ();
		g_once_init_leave (&pc_daemon_dbus_type_id__once, pc_daemon_dbus_type_id);
	}
	return pc_daemon_dbus_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (PCDaemonDBusProxy, pc_daemon_dbus_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (PC_DAEMON_TYPE_DBUS, pc_daemon_dbus_proxy_pc_daemon_dbus_interface_init) )
static void
pc_daemon_dbus_proxy_class_init (PCDaemonDBusProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = pc_daemon_dbus_proxy_g_signal;
}

static void
pc_daemon_dbus_proxy_g_signal (GDBusProxy* proxy,
                               const gchar* sender_name,
                               const gchar* signal_name,
                               GVariant* parameters)
{
}

static void
pc_daemon_dbus_proxy_init (PCDaemonDBusProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_pc_daemon_dbus_dbus_interface_info));
}

static guint32
pc_daemon_dbus_proxy_get_connection_unix_process_id (PCDaemonDBus* self,
                                                     const gchar* name,
                                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp2_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.DBus", "GetConnectionUnixProcessID");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		guint32 _tmp0_ = 0U;
		return _tmp0_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp1_ = 0U;
		g_object_unref (_reply_message);
		return _tmp1_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp2_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp2_);
	g_variant_unref (_tmp2_);
	g_object_unref (_reply_message);
	return _result;
}

static guint32
pc_daemon_dbus_proxy_get_connection_unix_user (PCDaemonDBus* self,
                                               const gchar* name,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp5_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.DBus", "GetConnectionUnixUser");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (name));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		guint32 _tmp3_ = 0U;
		return _tmp3_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp4_ = 0U;
		g_object_unref (_reply_message);
		return _tmp4_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp5_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp5_);
	g_variant_unref (_tmp5_);
	g_object_unref (_reply_message);
	return _result;
}

static void
pc_daemon_dbus_proxy_pc_daemon_dbus_interface_init (PCDaemonDBusIface* iface)
{
	iface->get_connection_unix_process_id = pc_daemon_dbus_proxy_get_connection_unix_process_id;
	iface->get_connection_unix_user = pc_daemon_dbus_proxy_get_connection_unix_user;
}

static void
_dbus_pc_daemon_dbus_get_connection_unix_process_id (PCDaemonDBus* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp6_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp6_, NULL);
	g_variant_unref (_tmp6_);
	result = pc_daemon_dbus_get_connection_unix_process_id (self, name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (name);
	;
}

static void
_dbus_pc_daemon_dbus_get_connection_unix_user (PCDaemonDBus* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* name = NULL;
	GVariant* _tmp7_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	name = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	result = pc_daemon_dbus_get_connection_unix_user (self, name, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (name);
	;
}

static void
pc_daemon_dbus_dbus_interface_method_call (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* method_name,
                                           GVariant* parameters,
                                           GDBusMethodInvocation* invocation,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetConnectionUnixProcessID") == 0) {
		_dbus_pc_daemon_dbus_get_connection_unix_process_id (object, parameters, invocation);
	} else if (strcmp (method_name, "GetConnectionUnixUser") == 0) {
		_dbus_pc_daemon_dbus_get_connection_unix_user (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
pc_daemon_dbus_dbus_interface_get_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
pc_daemon_dbus_dbus_interface_set_property (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* property_name,
                                            GVariant* value,
                                            GError** error,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
pc_daemon_dbus_register_object (gpointer object,
                                GDBusConnection* connection,
                                const gchar* path,
                                GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_pc_daemon_dbus_dbus_interface_info), &_pc_daemon_dbus_dbus_interface_vtable, data, _pc_daemon_dbus_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_pc_daemon_dbus_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

GQuark
pc_daemon_parental_controls_error_quark (void)
{
	static volatile gsize pc_daemon_parental_controls_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("pc-daemon-parental-controls-error-quark", &pc_daemon_parental_controls_error_quark_volatile, pc_daemon_parental_controls_error_entries, G_N_ELEMENTS (pc_daemon_parental_controls_error_entries));
	return (GQuark) pc_daemon_parental_controls_error_quark_volatile;
}

static inline gpointer
pc_daemon_server_get_instance_private (PCDaemonServer* self)
{
	return G_STRUCT_MEMBER_P (self, PCDaemonServer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/daemon/Server.vala"
	return self ? g_object_ref (self) : NULL;
#line 920 "Server.c"
}

PCDaemonServer*
pc_daemon_server_get_default (void)
{
	PCDaemonServer* _tmp0_;
	PCDaemonServer* _tmp2_;
	PCDaemonServer* _tmp3_;
	PCDaemonServer* result;
#line 48 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_instance;
#line 48 "../src/daemon/Server.vala"
	if (_tmp0_ == NULL) {
#line 934 "Server.c"
		PCDaemonServer* _tmp1_;
#line 49 "../src/daemon/Server.vala"
		_tmp1_ = pc_daemon_server_new ();
#line 49 "../src/daemon/Server.vala"
		_g_object_unref0 (pc_daemon_server_instance);
#line 49 "../src/daemon/Server.vala"
		pc_daemon_server_instance = _tmp1_;
#line 942 "Server.c"
	}
#line 52 "../src/daemon/Server.vala"
	_tmp2_ = pc_daemon_server_instance;
#line 52 "../src/daemon/Server.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 52 "../src/daemon/Server.vala"
	result = _tmp3_;
#line 52 "../src/daemon/Server.vala"
	return result;
#line 952 "Server.c"
}

static void
_pc_daemon_server_on_config_changed_pc_daemon_server_config_changed (PCDaemonServer* _sender,
                                                                     gpointer self)
{
#line 65 "../src/daemon/Server.vala"
	pc_daemon_server_on_config_changed ((PCDaemonServer*) self);
#line 961 "Server.c"
}

PCDaemonServer*
pc_daemon_server_construct (GType object_type)
{
	PCDaemonServer * self = NULL;
	GError* _inner_error0_ = NULL;
#line 55 "../src/daemon/Server.vala"
	self = (PCDaemonServer*) g_object_new (object_type, NULL);
#line 971 "Server.c"
	{
		PCDaemonDBus* _tmp0_ = NULL;
		PCDaemonDBus* _tmp1_;
		PCDaemonDBus* _tmp2_;
#line 57 "../src/daemon/Server.vala"
		_tmp1_ = (PCDaemonDBus*) g_initable_new (PC_DAEMON_TYPE_DBUS_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.freedesktop.DBus", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/", "g-interface-name", "org.freedesktop.DBus", NULL);
#line 57 "../src/daemon/Server.vala"
		_tmp0_ = (PCDaemonDBus*) _tmp1_;
#line 57 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 982 "Server.c"
			goto __catch0_g_error;
		}
#line 57 "../src/daemon/Server.vala"
		_tmp2_ = _tmp0_;
#line 57 "../src/daemon/Server.vala"
		_tmp0_ = NULL;
#line 57 "../src/daemon/Server.vala"
		_g_object_unref0 (self->priv->bus_proxy);
#line 57 "../src/daemon/Server.vala"
		self->priv->bus_proxy = _tmp2_;
#line 56 "../src/daemon/Server.vala"
		_g_object_unref0 (_tmp0_);
#line 995 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 56 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 56 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 59 "../src/daemon/Server.vala"
		_tmp3_ = e;
#line 59 "../src/daemon/Server.vala"
		_tmp4_ = _tmp3_->message;
#line 59 "../src/daemon/Server.vala"
		g_warning ("Server.vala:59: %s", _tmp4_);
#line 60 "../src/daemon/Server.vala"
		_g_object_unref0 (self->priv->bus_proxy);
#line 60 "../src/daemon/Server.vala"
		self->priv->bus_proxy = NULL;
#line 56 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 1019 "Server.c"
	}
	__finally0:
#line 56 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/daemon/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/daemon/Server.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../src/daemon/Server.vala"
		return NULL;
#line 1030 "Server.c"
	}
#line 63 "../src/daemon/Server.vala"
	pc_daemon_user_config_init ();
#line 65 "../src/daemon/Server.vala"
	g_signal_connect_object (self, "config-changed", (GCallback) _pc_daemon_server_on_config_changed_pc_daemon_server_config_changed, self, 0);
#line 55 "../src/daemon/Server.vala"
	return self;
#line 1038 "Server.c"
}

PCDaemonServer*
pc_daemon_server_new (void)
{
#line 55 "../src/daemon/Server.vala"
	return pc_daemon_server_construct (PC_DAEMON_TYPE_SERVER);
#line 1046 "Server.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 72 "../src/daemon/Server.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 72 "../src/daemon/Server.vala"
	return _data2_;
#line 1056 "Server.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 72 "../src/daemon/Server.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1066 "Server.c"
		PCDaemonServer* self;
#line 72 "../src/daemon/Server.vala"
		self = _data2_->self;
#line 72 "../src/daemon/Server.vala"
		_g_free0 (_data2_->username);
#line 72 "../src/daemon/Server.vala"
		_g_object_unref0 (self);
#line 72 "../src/daemon/Server.vala"
		g_slice_free (Block2Data, _data2_);
#line 1076 "Server.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 94 "../src/daemon/Server.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 94 "../src/daemon/Server.vala"
	return _data3_;
#line 1087 "Server.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 94 "../src/daemon/Server.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1097 "Server.c"
		PCDaemonServer* self;
#line 94 "../src/daemon/Server.vala"
		self = _data3_->_data2_->self;
#line 94 "../src/daemon/Server.vala"
		_g_free0 (_data3_->path);
#line 94 "../src/daemon/Server.vala"
		block2_data_unref (_data3_->_data2_);
#line 94 "../src/daemon/Server.vala"
		_data3_->_data2_ = NULL;
#line 94 "../src/daemon/Server.vala"
		g_slice_free (Block3Data, _data3_);
#line 1109 "Server.c"
	}
}

static void
____lambda12_ (Block3Data* _data3_,
               gchar** args,
               gint args_length1,
               gboolean incoming)
{
	Block2Data* _data2_;
	PCDaemonServer* self;
	const gchar* _tmp0_;
#line 104 "../src/daemon/Server.vala"
	_data2_ = _data3_->_data2_;
#line 104 "../src/daemon/Server.vala"
	self = _data2_->self;
#line 105 "../src/daemon/Server.vala"
	if (incoming) {
#line 106 "../src/daemon/Server.vala"
		return;
#line 1130 "Server.c"
	}
#line 109 "../src/daemon/Server.vala"
	g_signal_handler_disconnect ((GObject*) self, _data3_->launch_signal_id);
#line 110 "../src/daemon/Server.vala"
	if (_data3_->timeout_signal_id != 0U) {
#line 111 "../src/daemon/Server.vala"
		g_source_remove (_data3_->timeout_signal_id);
#line 1138 "Server.c"
	}
#line 114 "../src/daemon/Server.vala"
	_tmp0_ = _data3_->path;
#line 114 "../src/daemon/Server.vala"
	pc_access_control_lists_setfacl (_data2_->username, _tmp0_, PC_ACCESS_CONTROL_LISTS_NO_EXEC_PERMISSIONS);
#line 1144 "Server.c"
}

static void
_____lambda12__pc_daemon_server_launch (PCDaemonServer* _sender,
                                        gchar** args,
                                        gint args_length1,
                                        gboolean incoming,
                                        gpointer self)
{
#line 104 "../src/daemon/Server.vala"
	____lambda12_ (self, args, args_length1, incoming);
#line 1156 "Server.c"
}

static gboolean
____lambda13_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	PCDaemonServer* self;
	const gchar* _tmp0_;
	gboolean result;
#line 117 "../src/daemon/Server.vala"
	_data2_ = _data3_->_data2_;
#line 117 "../src/daemon/Server.vala"
	self = _data2_->self;
#line 118 "../src/daemon/Server.vala"
	g_warning ("Server.vala:118: Max timeout reached (%u ms): client did not respond.", PC_DAEMON_SERVER_CLIENT_LAUNCH_TIMEOUT);
#line 119 "../src/daemon/Server.vala"
	if (_data3_->launch_signal_id != ((gulong) 0U)) {
#line 120 "../src/daemon/Server.vala"
		g_signal_handler_disconnect ((GObject*) self, _data3_->launch_signal_id);
#line 1176 "Server.c"
	}
#line 123 "../src/daemon/Server.vala"
	_tmp0_ = _data3_->path;
#line 123 "../src/daemon/Server.vala"
	pc_access_control_lists_setfacl (_data2_->username, _tmp0_, PC_ACCESS_CONTROL_LISTS_NO_EXEC_PERMISSIONS);
#line 124 "../src/daemon/Server.vala"
	result = FALSE;
#line 124 "../src/daemon/Server.vala"
	return result;
#line 1186 "Server.c"
}

static gboolean
_____lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda13_ (self);
#line 117 "../src/daemon/Server.vala"
	return result;
#line 1196 "Server.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 130 "../src/daemon/Server.vala"
	return self ? g_error_copy (self) : NULL;
#line 1204 "Server.c"
}

void
pc_daemon_server_finish_app_authorization (PCDaemonServer* self,
                                           const char* sender,
                                           const gchar* username,
                                           gchar** args,
                                           gint args_length1,
                                           GError** error)
{
	Block2Data* _data2_;
	gchar* _tmp0_;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp1_;
	gboolean _tmp2_ = FALSE;
	PCDaemonUserConfig* _tmp3_;
	guint32 client_pid = 0U;
	PolkitAuthority* authority = NULL;
	PolkitAuthority* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 72 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 72 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 72 "../src/daemon/Server.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 72 "../src/daemon/Server.vala"
	_data2_->_ref_count_ = 1;
#line 72 "../src/daemon/Server.vala"
	_data2_->self = g_object_ref (self);
#line 72 "../src/daemon/Server.vala"
	_tmp0_ = g_strdup (username);
#line 72 "../src/daemon/Server.vala"
	_g_free0 (_data2_->username);
#line 72 "../src/daemon/Server.vala"
	_data2_->username = _tmp0_;
#line 77 "../src/daemon/Server.vala"
	_tmp1_ = pc_daemon_user_config_get_for_username (_data2_->username, FALSE);
#line 77 "../src/daemon/Server.vala"
	config = _tmp1_;
#line 78 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 78 "../src/daemon/Server.vala"
	if (_tmp3_ == NULL) {
#line 78 "../src/daemon/Server.vala"
		_tmp2_ = TRUE;
#line 1253 "Server.c"
	} else {
		PCDaemonUserConfig* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 78 "../src/daemon/Server.vala"
		_tmp4_ = config;
#line 78 "../src/daemon/Server.vala"
		_tmp5_ = pc_daemon_user_config_get_admin (_tmp4_);
#line 78 "../src/daemon/Server.vala"
		_tmp6_ = _tmp5_;
#line 78 "../src/daemon/Server.vala"
		_tmp2_ = !_tmp6_;
#line 1266 "Server.c"
	}
#line 78 "../src/daemon/Server.vala"
	if (_tmp2_) {
#line 1270 "Server.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 79 "../src/daemon/Server.vala"
		_tmp7_ = g_strdup_printf ("Error: config for %s is not valid or does not have an ability to autho" \
"rize", _data2_->username);
#line 79 "../src/daemon/Server.vala"
		_tmp8_ = _tmp7_;
#line 79 "../src/daemon/Server.vala"
		_tmp9_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, _tmp8_);
#line 79 "../src/daemon/Server.vala"
		_tmp10_ = _tmp9_;
#line 79 "../src/daemon/Server.vala"
		_g_free0 (_tmp8_);
#line 79 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp10_;
#line 79 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 79 "../src/daemon/Server.vala"
		block2_data_unref (_data2_);
#line 79 "../src/daemon/Server.vala"
		_data2_ = NULL;
#line 79 "../src/daemon/Server.vala"
		return;
#line 1297 "Server.c"
	}
#line 84 "../src/daemon/Server.vala"
	client_pid = pc_daemon_server_get_pid_from_sender (self, sender);
#line 85 "../src/daemon/Server.vala"
	_tmp11_ = polkit_authority_get_sync (NULL, &_inner_error0_);
#line 85 "../src/daemon/Server.vala"
	authority = _tmp11_;
#line 85 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 85 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 85 "../src/daemon/Server.vala"
		block2_data_unref (_data2_);
#line 85 "../src/daemon/Server.vala"
		_data2_ = NULL;
#line 85 "../src/daemon/Server.vala"
		return;
#line 1317 "Server.c"
	}
	{
		PolkitUnixUser* unix_user = NULL;
		PolkitUnixUser* _tmp12_;
		PolkitAuthorizationResult* _result_ = NULL;
		PolkitAuthority* _tmp13_;
		PolkitUnixUser* _tmp14_;
		PolkitUnixProcess* _tmp15_;
		PolkitUnixProcess* _tmp16_;
		PolkitAuthorizationResult* _tmp17_;
		PolkitAuthorizationResult* _tmp18_;
		PolkitAuthorizationResult* _tmp19_;
#line 87 "../src/daemon/Server.vala"
		_tmp12_ = (PolkitUnixUser*) polkit_unix_user_new_for_name (_data2_->username, &_inner_error0_);
#line 87 "../src/daemon/Server.vala"
		unix_user = _tmp12_;
#line 87 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1336 "Server.c"
			goto __catch0_g_error;
		}
#line 88 "../src/daemon/Server.vala"
		_tmp13_ = authority;
#line 88 "../src/daemon/Server.vala"
		_tmp14_ = unix_user;
#line 88 "../src/daemon/Server.vala"
		_tmp15_ = (PolkitUnixProcess*) polkit_unix_process_new_for_owner ((gint) client_pid, (guint64) 0, polkit_unix_user_get_uid (_tmp14_));
#line 88 "../src/daemon/Server.vala"
		_tmp16_ = _tmp15_;
#line 88 "../src/daemon/Server.vala"
		_tmp17_ = polkit_authority_check_authorization_sync (_tmp13_, (PolkitSubject*) _tmp16_, PC_CONSTANTS_PARENTAL_CONTROLS_ACTION_ID, NULL, POLKIT_CHECK_AUTHORIZATION_FLAGS_NONE, NULL, &_inner_error0_);
#line 88 "../src/daemon/Server.vala"
		_tmp18_ = _tmp17_;
#line 88 "../src/daemon/Server.vala"
		_g_object_unref0 (_tmp16_);
#line 88 "../src/daemon/Server.vala"
		_result_ = _tmp18_;
#line 88 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/daemon/Server.vala"
			_g_object_unref0 (unix_user);
#line 1359 "Server.c"
			goto __catch0_g_error;
		}
#line 94 "../src/daemon/Server.vala"
		_tmp19_ = _result_;
#line 94 "../src/daemon/Server.vala"
		if (polkit_authorization_result_get_is_authorized (_tmp19_)) {
#line 1366 "Server.c"
			Block3Data* _data3_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp25_;
			gulong _tmp26_;
#line 94 "../src/daemon/Server.vala"
			_data3_ = g_slice_new0 (Block3Data);
#line 94 "../src/daemon/Server.vala"
			_data3_->_ref_count_ = 1;
#line 94 "../src/daemon/Server.vala"
			_data3_->_data2_ = block2_data_ref (_data2_);
#line 95 "../src/daemon/Server.vala"
			_tmp20_ = args[0];
#line 95 "../src/daemon/Server.vala"
			_tmp21_ = g_find_program_in_path (_tmp20_);
#line 95 "../src/daemon/Server.vala"
			_data3_->path = _tmp21_;
#line 96 "../src/daemon/Server.vala"
			_tmp22_ = _data3_->path;
#line 96 "../src/daemon/Server.vala"
			if (_tmp22_ == NULL) {
#line 1389 "Server.c"
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 97 "../src/daemon/Server.vala"
				_tmp23_ = args[0];
#line 97 "../src/daemon/Server.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 97 "../src/daemon/Server.vala"
				_g_free0 (_data3_->path);
#line 97 "../src/daemon/Server.vala"
				_data3_->path = _tmp24_;
#line 1400 "Server.c"
			}
#line 100 "../src/daemon/Server.vala"
			_tmp25_ = _data3_->path;
#line 100 "../src/daemon/Server.vala"
			pc_access_control_lists_setfacl (_data2_->username, _tmp25_, "--x");
#line 101 "../src/daemon/Server.vala"
			_data3_->launch_signal_id = (gulong) 0U;
#line 102 "../src/daemon/Server.vala"
			_data3_->timeout_signal_id = 0U;
#line 104 "../src/daemon/Server.vala"
			_tmp26_ = g_signal_connect_data (self, "launch", (GCallback) _____lambda12__pc_daemon_server_launch, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 104 "../src/daemon/Server.vala"
			_data3_->launch_signal_id = _tmp26_;
#line 117 "../src/daemon/Server.vala"
			_data3_->timeout_signal_id = g_timeout_add_full (G_PRIORITY_DEFAULT, PC_DAEMON_SERVER_CLIENT_LAUNCH_TIMEOUT, _____lambda13__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 127 "../src/daemon/Server.vala"
			g_signal_emit (self, pc_daemon_server_signals[PC_DAEMON_SERVER_LAUNCH_SIGNAL], 0, args, (gint) args_length1, TRUE);
#line 94 "../src/daemon/Server.vala"
			block3_data_unref (_data3_);
#line 94 "../src/daemon/Server.vala"
			_data3_ = NULL;
#line 1422 "Server.c"
		}
#line 86 "../src/daemon/Server.vala"
		_g_object_unref0 (_result_);
#line 86 "../src/daemon/Server.vala"
		_g_object_unref0 (unix_user);
#line 1428 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		GError* _tmp28_;
#line 86 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 86 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 130 "../src/daemon/Server.vala"
		_tmp27_ = e;
#line 130 "../src/daemon/Server.vala"
		_tmp28_ = _g_error_copy0 (_tmp27_);
#line 130 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp28_;
#line 130 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 1448 "Server.c"
		goto __finally0;
	}
	__finally0:
#line 86 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 86 "../src/daemon/Server.vala"
		_g_object_unref0 (authority);
#line 86 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 86 "../src/daemon/Server.vala"
		block2_data_unref (_data2_);
#line 86 "../src/daemon/Server.vala"
		_data2_ = NULL;
#line 86 "../src/daemon/Server.vala"
		return;
#line 1466 "Server.c"
	}
#line 72 "../src/daemon/Server.vala"
	_g_object_unref0 (authority);
#line 72 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 72 "../src/daemon/Server.vala"
	block2_data_unref (_data2_);
#line 72 "../src/daemon/Server.vala"
	_data2_ = NULL;
#line 1476 "Server.c"
}

void
pc_daemon_server_add_restriction_for_user (PCDaemonServer* self,
                                           const gchar* input,
                                           gboolean clean,
                                           const char* sender,
                                           GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCPAMWriter* writer = NULL;
	PCPAMWriter* _tmp2_;
	PCPAMWriter* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 134 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/daemon/Server.vala"
	g_return_if_fail (input != NULL);
#line 134 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 139 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 139 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 139 "../src/daemon/Server.vala"
		return;
#line 1505 "Server.c"
	}
#line 139 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1509 "Server.c"
		GError* _tmp1_;
#line 140 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 140 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 140 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 140 "../src/daemon/Server.vala"
		return;
#line 1519 "Server.c"
	}
#line 143 "../src/daemon/Server.vala"
	pc_daemon_server_ensure_pam_lightdm_enabled (self);
#line 145 "../src/daemon/Server.vala"
	_tmp2_ = pc_pam_writer_new_for_time ();
#line 145 "../src/daemon/Server.vala"
	writer = _tmp2_;
#line 146 "../src/daemon/Server.vala"
	_tmp3_ = writer;
#line 146 "../src/daemon/Server.vala"
	pc_pam_writer_add_restriction_for_user (_tmp3_, input, clean);
#line 134 "../src/daemon/Server.vala"
	_g_object_unref0 (writer);
#line 1533 "Server.c"
}

void
pc_daemon_server_remove_restriction_for_user (PCDaemonServer* self,
                                              const gchar* username,
                                              const char* sender,
                                              GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCPAMWriter* writer = NULL;
	PCPAMWriter* _tmp2_;
	PCPAMWriter* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 149 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 149 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 153 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 153 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 153 "../src/daemon/Server.vala"
		return;
#line 1561 "Server.c"
	}
#line 153 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1565 "Server.c"
		GError* _tmp1_;
#line 154 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 154 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 154 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 154 "../src/daemon/Server.vala"
		return;
#line 1575 "Server.c"
	}
#line 157 "../src/daemon/Server.vala"
	_tmp2_ = pc_pam_writer_new_for_time ();
#line 157 "../src/daemon/Server.vala"
	writer = _tmp2_;
#line 158 "../src/daemon/Server.vala"
	_tmp3_ = writer;
#line 158 "../src/daemon/Server.vala"
	pc_pam_writer_remove_restriction_for_user (_tmp3_, username);
#line 149 "../src/daemon/Server.vala"
	_g_object_unref0 (writer);
#line 1587 "Server.c"
}

void
pc_daemon_server_lock_dock_icons_for_user (PCDaemonServer* self,
                                           const gchar* username,
                                           gboolean lock,
                                           const char* sender,
                                           GError** error)
{
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 161 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 161 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 166 "../src/daemon/Server.vala"
	_tmp0_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_IMPLEMENTED, "Error: not implemented");
#line 166 "../src/daemon/Server.vala"
	_inner_error0_ = _tmp0_;
#line 166 "../src/daemon/Server.vala"
	g_propagate_error (error, _inner_error0_);
#line 166 "../src/daemon/Server.vala"
	return;
#line 1613 "Server.c"
}

void
pc_daemon_server_set_user_daemon_active (PCDaemonServer* self,
                                         const gchar* username,
                                         gboolean active,
                                         const char* sender,
                                         GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp2_;
	PCDaemonUserConfig* _tmp3_;
	PCDaemonUserConfig* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 169 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 169 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 174 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 174 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 174 "../src/daemon/Server.vala"
		return;
#line 1643 "Server.c"
	}
#line 174 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1647 "Server.c"
		GError* _tmp1_;
#line 175 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 175 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 175 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 175 "../src/daemon/Server.vala"
		return;
#line 1657 "Server.c"
	}
#line 178 "../src/daemon/Server.vala"
	_tmp2_ = pc_daemon_user_config_get_for_username (username, TRUE);
#line 178 "../src/daemon/Server.vala"
	config = _tmp2_;
#line 179 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 179 "../src/daemon/Server.vala"
	if (_tmp3_ == NULL) {
#line 1667 "Server.c"
		GError* _tmp4_;
#line 180 "../src/daemon/Server.vala"
		_tmp4_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or could not be created", username);
#line 180 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp4_;
#line 180 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 180 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 180 "../src/daemon/Server.vala"
		return;
#line 1679 "Server.c"
	}
#line 185 "../src/daemon/Server.vala"
	_tmp5_ = config;
#line 185 "../src/daemon/Server.vala"
	pc_daemon_user_config_set_active (_tmp5_, active);
#line 169 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 1687 "Server.c"
}

void
pc_daemon_server_set_user_daemon_targets (PCDaemonServer* self,
                                          const gchar* username,
                                          gchar** targets,
                                          gint targets_length1,
                                          const char* sender,
                                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp2_;
	PCDaemonUserConfig* _tmp3_;
	PCDaemonUserConfig* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 188 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 188 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 193 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 193 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 193 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 193 "../src/daemon/Server.vala"
		return;
#line 1718 "Server.c"
	}
#line 193 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1722 "Server.c"
		GError* _tmp1_;
#line 194 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 194 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 194 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 194 "../src/daemon/Server.vala"
		return;
#line 1732 "Server.c"
	}
#line 197 "../src/daemon/Server.vala"
	_tmp2_ = pc_daemon_user_config_get_for_username (username, TRUE);
#line 197 "../src/daemon/Server.vala"
	config = _tmp2_;
#line 198 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 198 "../src/daemon/Server.vala"
	if (_tmp3_ == NULL) {
#line 1742 "Server.c"
		GError* _tmp4_;
#line 199 "../src/daemon/Server.vala"
		_tmp4_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or could not be created", username);
#line 199 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp4_;
#line 199 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 199 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 199 "../src/daemon/Server.vala"
		return;
#line 1754 "Server.c"
	}
#line 204 "../src/daemon/Server.vala"
	_tmp5_ = config;
#line 204 "../src/daemon/Server.vala"
	pc_daemon_user_config_set_targets (_tmp5_, targets, targets_length1);
#line 188 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 1762 "Server.c"
}

void
pc_daemon_server_set_user_daemon_block_urls (PCDaemonServer* self,
                                             const gchar* username,
                                             gchar** block_urls,
                                             gint block_urls_length1,
                                             const char* sender,
                                             GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp2_;
	PCDaemonUserConfig* _tmp3_;
	PCDaemonUserConfig* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 207 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 207 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 212 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 212 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 212 "../src/daemon/Server.vala"
		return;
#line 1793 "Server.c"
	}
#line 212 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1797 "Server.c"
		GError* _tmp1_;
#line 213 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 213 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 213 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 213 "../src/daemon/Server.vala"
		return;
#line 1807 "Server.c"
	}
#line 216 "../src/daemon/Server.vala"
	_tmp2_ = pc_daemon_user_config_get_for_username (username, TRUE);
#line 216 "../src/daemon/Server.vala"
	config = _tmp2_;
#line 217 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 217 "../src/daemon/Server.vala"
	if (_tmp3_ == NULL) {
#line 1817 "Server.c"
		GError* _tmp4_;
#line 218 "../src/daemon/Server.vala"
		_tmp4_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or could not be created", username);
#line 218 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp4_;
#line 218 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 218 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 218 "../src/daemon/Server.vala"
		return;
#line 1829 "Server.c"
	}
#line 223 "../src/daemon/Server.vala"
	_tmp5_ = config;
#line 223 "../src/daemon/Server.vala"
	pc_daemon_user_config_set_block_urls (_tmp5_, block_urls, block_urls_length1);
#line 207 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 1837 "Server.c"
}

void
pc_daemon_server_set_user_daemon_admin (PCDaemonServer* self,
                                        const gchar* username,
                                        gboolean admin,
                                        const char* sender,
                                        GError** error)
{
	gboolean _tmp0_ = FALSE;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp2_;
	PCDaemonUserConfig* _tmp3_;
	PCDaemonUserConfig* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 226 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/daemon/Server.vala"
	g_return_if_fail (username != NULL);
#line 226 "../src/daemon/Server.vala"
	g_return_if_fail (sender != NULL);
#line 231 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_server_get_sender_is_authorized (self, sender, &_inner_error0_);
#line 231 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 231 "../src/daemon/Server.vala"
		return;
#line 1867 "Server.c"
	}
#line 231 "../src/daemon/Server.vala"
	if (!_tmp0_) {
#line 1871 "Server.c"
		GError* _tmp1_;
#line 232 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_NOT_AUTHORIZED, "Error: sender not authorized");
#line 232 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 232 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 232 "../src/daemon/Server.vala"
		return;
#line 1881 "Server.c"
	}
#line 235 "../src/daemon/Server.vala"
	_tmp2_ = pc_daemon_user_config_get_for_username (username, TRUE);
#line 235 "../src/daemon/Server.vala"
	config = _tmp2_;
#line 236 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 236 "../src/daemon/Server.vala"
	if (_tmp3_ == NULL) {
#line 1891 "Server.c"
		GError* _tmp4_;
#line 237 "../src/daemon/Server.vala"
		_tmp4_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or could not be created", username);
#line 237 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp4_;
#line 237 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 237 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 237 "../src/daemon/Server.vala"
		return;
#line 1903 "Server.c"
	}
#line 242 "../src/daemon/Server.vala"
	_tmp5_ = config;
#line 242 "../src/daemon/Server.vala"
	pc_daemon_user_config_set_admin (_tmp5_, admin);
#line 226 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 1911 "Server.c"
}

gboolean
pc_daemon_server_get_user_daemon_active (PCDaemonServer* self,
                                         const gchar* username,
                                         GError** error)
{
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp0_;
	PCDaemonUserConfig* _tmp1_;
	PCDaemonUserConfig* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 245 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 245 "../src/daemon/Server.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 246 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_user_config_get_for_username (username, FALSE);
#line 246 "../src/daemon/Server.vala"
	config = _tmp0_;
#line 247 "../src/daemon/Server.vala"
	_tmp1_ = config;
#line 247 "../src/daemon/Server.vala"
	if (_tmp1_ == NULL) {
#line 1939 "Server.c"
		GError* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 248 "../src/daemon/Server.vala"
		_tmp2_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or does not exist", username);
#line 248 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp2_;
#line 248 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 248 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 248 "../src/daemon/Server.vala"
		return _tmp3_;
#line 1952 "Server.c"
	}
#line 253 "../src/daemon/Server.vala"
	_tmp4_ = config;
#line 253 "../src/daemon/Server.vala"
	_tmp5_ = pc_daemon_user_config_get_active (_tmp4_);
#line 253 "../src/daemon/Server.vala"
	_tmp6_ = _tmp5_;
#line 253 "../src/daemon/Server.vala"
	result = _tmp6_;
#line 253 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 253 "../src/daemon/Server.vala"
	return result;
#line 1966 "Server.c"
}

gchar**
pc_daemon_server_get_user_daemon_targets (PCDaemonServer* self,
                                          const gchar* username,
                                          gint* result_length1,
                                          GError** error)
{
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp0_;
	PCDaemonUserConfig* _tmp1_;
	PCDaemonUserConfig* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 256 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/daemon/Server.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 257 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_user_config_get_for_username (username, FALSE);
#line 257 "../src/daemon/Server.vala"
	config = _tmp0_;
#line 258 "../src/daemon/Server.vala"
	_tmp1_ = config;
#line 258 "../src/daemon/Server.vala"
	if (_tmp1_ == NULL) {
#line 2000 "Server.c"
		GError* _tmp2_;
#line 259 "../src/daemon/Server.vala"
		_tmp2_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or does not exist", username);
#line 259 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp2_;
#line 259 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 259 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 259 "../src/daemon/Server.vala"
		return NULL;
#line 2012 "Server.c"
	}
#line 264 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 264 "../src/daemon/Server.vala"
	_tmp4_ = pc_daemon_user_config_get_targets (_tmp3_, &_tmp5_);
#line 264 "../src/daemon/Server.vala"
	_tmp4__length1 = _tmp5_;
#line 264 "../src/daemon/Server.vala"
	_tmp6_ = _tmp4_;
#line 264 "../src/daemon/Server.vala"
	_tmp6__length1 = _tmp4__length1;
#line 264 "../src/daemon/Server.vala"
	_tmp7_ = _tmp6_;
#line 264 "../src/daemon/Server.vala"
	_tmp7__length1 = _tmp6__length1;
#line 264 "../src/daemon/Server.vala"
	if (result_length1) {
#line 264 "../src/daemon/Server.vala"
		*result_length1 = _tmp7__length1;
#line 2032 "Server.c"
	}
#line 264 "../src/daemon/Server.vala"
	result = _tmp7_;
#line 264 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 264 "../src/daemon/Server.vala"
	return result;
#line 2040 "Server.c"
}

gchar**
pc_daemon_server_get_user_daemon_block_urls (PCDaemonServer* self,
                                             const gchar* username,
                                             gint* result_length1,
                                             GError** error)
{
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp0_;
	PCDaemonUserConfig* _tmp1_;
	PCDaemonUserConfig* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 267 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../src/daemon/Server.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 268 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_user_config_get_for_username (username, FALSE);
#line 268 "../src/daemon/Server.vala"
	config = _tmp0_;
#line 269 "../src/daemon/Server.vala"
	_tmp1_ = config;
#line 269 "../src/daemon/Server.vala"
	if (_tmp1_ == NULL) {
#line 2074 "Server.c"
		GError* _tmp2_;
#line 270 "../src/daemon/Server.vala"
		_tmp2_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or does not exist", username);
#line 270 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp2_;
#line 270 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 270 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 270 "../src/daemon/Server.vala"
		return NULL;
#line 2086 "Server.c"
	}
#line 275 "../src/daemon/Server.vala"
	_tmp3_ = config;
#line 275 "../src/daemon/Server.vala"
	_tmp4_ = pc_daemon_user_config_get_block_urls (_tmp3_, &_tmp5_);
#line 275 "../src/daemon/Server.vala"
	_tmp4__length1 = _tmp5_;
#line 275 "../src/daemon/Server.vala"
	_tmp6_ = _tmp4_;
#line 275 "../src/daemon/Server.vala"
	_tmp6__length1 = _tmp4__length1;
#line 275 "../src/daemon/Server.vala"
	_tmp7_ = _tmp6_;
#line 275 "../src/daemon/Server.vala"
	_tmp7__length1 = _tmp6__length1;
#line 275 "../src/daemon/Server.vala"
	if (result_length1) {
#line 275 "../src/daemon/Server.vala"
		*result_length1 = _tmp7__length1;
#line 2106 "Server.c"
	}
#line 275 "../src/daemon/Server.vala"
	result = _tmp7_;
#line 275 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 275 "../src/daemon/Server.vala"
	return result;
#line 2114 "Server.c"
}

gboolean
pc_daemon_server_get_user_daemon_admin (PCDaemonServer* self,
                                        const gchar* username,
                                        GError** error)
{
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp0_;
	PCDaemonUserConfig* _tmp1_;
	PCDaemonUserConfig* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 278 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 278 "../src/daemon/Server.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 279 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_user_config_get_for_username (username, FALSE);
#line 279 "../src/daemon/Server.vala"
	config = _tmp0_;
#line 280 "../src/daemon/Server.vala"
	_tmp1_ = config;
#line 280 "../src/daemon/Server.vala"
	if (_tmp1_ == NULL) {
#line 2142 "Server.c"
		GError* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 281 "../src/daemon/Server.vala"
		_tmp2_ = g_error_new (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_USER_CONFIG_NOT_VAILD, "Error: config for %s is not valid or does not exist", username);
#line 281 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp2_;
#line 281 "../src/daemon/Server.vala"
		g_propagate_error (error, _inner_error0_);
#line 281 "../src/daemon/Server.vala"
		_g_object_unref0 (config);
#line 281 "../src/daemon/Server.vala"
		return _tmp3_;
#line 2155 "Server.c"
	}
#line 286 "../src/daemon/Server.vala"
	_tmp4_ = config;
#line 286 "../src/daemon/Server.vala"
	_tmp5_ = pc_daemon_user_config_get_admin (_tmp4_);
#line 286 "../src/daemon/Server.vala"
	_tmp6_ = _tmp5_;
#line 286 "../src/daemon/Server.vala"
	result = _tmp6_;
#line 286 "../src/daemon/Server.vala"
	_g_object_unref0 (config);
#line 286 "../src/daemon/Server.vala"
	return result;
#line 2169 "Server.c"
}

static void
pc_daemon_server_on_config_changed (PCDaemonServer* self)
{
	PCDaemonSessionHandler* current_handler = NULL;
	PCDaemonSessionManager* _tmp0_;
	PCDaemonSessionManager* _tmp1_;
	PCDaemonSessionHandler* _tmp2_;
	PCDaemonSessionHandler* _tmp3_;
	PCDaemonSessionHandler* _tmp4_;
	PCDaemonSessionHandler* _tmp5_;
#line 289 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/daemon/Server.vala"
	_tmp0_ = pc_daemon_session_manager_get_default ();
#line 290 "../src/daemon/Server.vala"
	_tmp1_ = _tmp0_;
#line 290 "../src/daemon/Server.vala"
	_tmp2_ = _tmp1_->current_handler;
#line 290 "../src/daemon/Server.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 290 "../src/daemon/Server.vala"
	_tmp4_ = _tmp3_;
#line 290 "../src/daemon/Server.vala"
	_g_object_unref0 (_tmp1_);
#line 290 "../src/daemon/Server.vala"
	current_handler = _tmp4_;
#line 291 "../src/daemon/Server.vala"
	_tmp5_ = current_handler;
#line 291 "../src/daemon/Server.vala"
	if (_tmp5_ != NULL) {
#line 2202 "Server.c"
		PCDaemonSessionHandler* _tmp6_;
#line 292 "../src/daemon/Server.vala"
		_tmp6_ = current_handler;
#line 292 "../src/daemon/Server.vala"
		pc_daemon_session_handler_update (_tmp6_);
#line 2208 "Server.c"
	}
#line 289 "../src/daemon/Server.vala"
	_g_object_unref0 (current_handler);
#line 2212 "Server.c"
}

static void
_vala_array_add2 (const gchar** * array,
                  gint* length,
                  gint* size,
                  const gchar* value)
{
#line 300 "../src/daemon/Server.vala"
	if ((*length) == (*size)) {
#line 300 "../src/daemon/Server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 300 "../src/daemon/Server.vala"
		*array = g_renew (const gchar*, *array, (*size) + 1);
#line 2227 "Server.c"
	}
#line 300 "../src/daemon/Server.vala"
	(*array)[(*length)++] = value;
#line 300 "../src/daemon/Server.vala"
	(*array)[*length] = NULL;
#line 2233 "Server.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2252 "Server.c"
}

static void
pc_daemon_server_ensure_pam_lightdm_enabled (PCDaemonServer* self)
{
	const gchar** config_dirs = NULL;
	const gchar* _tmp0_;
	const gchar** _tmp1_;
	gint config_dirs_length1;
	gint _config_dirs_size_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar* path = NULL;
	const gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp11_;
	gchar* contents = NULL;
	gchar* conf_line = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 296 "../src/daemon/Server.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/daemon/Server.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 298 "../src/daemon/Server.vala"
	_tmp1_ = g_new0 (const gchar*, 0 + 1);
#line 298 "../src/daemon/Server.vala"
	_tmp1_[0] = _tmp0_;
#line 298 "../src/daemon/Server.vala"
	config_dirs = _tmp1_;
#line 298 "../src/daemon/Server.vala"
	config_dirs_length1 = 0;
#line 298 "../src/daemon/Server.vala"
	_config_dirs_size_ = config_dirs_length1;
#line 299 "../src/daemon/Server.vala"
	_tmp3_ = _tmp2_ = g_get_system_config_dirs ();
#line 2294 "Server.c"
	{
		gchar** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 299 "../src/daemon/Server.vala"
		dir_collection = _tmp3_;
#line 299 "../src/daemon/Server.vala"
		dir_collection_length1 = _vala_array_length (_tmp2_);
#line 299 "../src/daemon/Server.vala"
		for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 2306 "Server.c"
			const gchar* dir = NULL;
#line 299 "../src/daemon/Server.vala"
			dir = dir_collection[dir_it];
#line 2310 "Server.c"
			{
				const gchar* _tmp4_;
#line 300 "../src/daemon/Server.vala"
				_tmp4_ = dir;
#line 300 "../src/daemon/Server.vala"
				_vala_array_add2 (&config_dirs, &config_dirs_length1, &_config_dirs_size_, _tmp4_);
#line 2317 "Server.c"
			}
		}
	}
#line 303 "../src/daemon/Server.vala"
	path = NULL;
#line 304 "../src/daemon/Server.vala"
	_tmp5_ = config_dirs;
#line 304 "../src/daemon/Server.vala"
	_tmp5__length1 = config_dirs_length1;
#line 2327 "Server.c"
	{
		const gchar** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 304 "../src/daemon/Server.vala"
		dir_collection = _tmp5_;
#line 304 "../src/daemon/Server.vala"
		dir_collection_length1 = _tmp5__length1;
#line 304 "../src/daemon/Server.vala"
		for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 2339 "Server.c"
			const gchar* dir = NULL;
#line 304 "../src/daemon/Server.vala"
			dir = dir_collection[dir_it];
#line 2343 "Server.c"
			{
				gchar* file_path = NULL;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
#line 305 "../src/daemon/Server.vala"
				_tmp6_ = dir;
#line 305 "../src/daemon/Server.vala"
				_tmp7_ = g_build_filename (_tmp6_, "pam.d", "lightdm", NULL);
#line 305 "../src/daemon/Server.vala"
				file_path = _tmp7_;
#line 306 "../src/daemon/Server.vala"
				_tmp8_ = file_path;
#line 306 "../src/daemon/Server.vala"
				if (g_file_test (_tmp8_, G_FILE_TEST_EXISTS)) {
#line 2359 "Server.c"
					const gchar* _tmp9_;
					gchar* _tmp10_;
#line 307 "../src/daemon/Server.vala"
					_tmp9_ = file_path;
#line 307 "../src/daemon/Server.vala"
					_tmp10_ = g_strdup (_tmp9_);
#line 307 "../src/daemon/Server.vala"
					_g_free0 (path);
#line 307 "../src/daemon/Server.vala"
					path = _tmp10_;
#line 308 "../src/daemon/Server.vala"
					_g_free0 (file_path);
#line 308 "../src/daemon/Server.vala"
					break;
#line 2374 "Server.c"
				}
#line 304 "../src/daemon/Server.vala"
				_g_free0 (file_path);
#line 2378 "Server.c"
			}
		}
	}
#line 312 "../src/daemon/Server.vala"
	_tmp11_ = path;
#line 312 "../src/daemon/Server.vala"
	if (_tmp11_ == NULL) {
#line 313 "../src/daemon/Server.vala"
		g_critical ("Server.vala:313: No pam.d lightdm found");
#line 314 "../src/daemon/Server.vala"
		_g_free0 (path);
#line 314 "../src/daemon/Server.vala"
		config_dirs = (g_free (config_dirs), NULL);
#line 314 "../src/daemon/Server.vala"
		return;
#line 2394 "Server.c"
	}
	{
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
#line 319 "../src/daemon/Server.vala"
		_tmp12_ = path;
#line 319 "../src/daemon/Server.vala"
		g_file_get_contents (_tmp12_, &_tmp13_, NULL, &_inner_error0_);
#line 319 "../src/daemon/Server.vala"
		_g_free0 (contents);
#line 319 "../src/daemon/Server.vala"
		contents = _tmp13_;
#line 319 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 319 "../src/daemon/Server.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2411 "Server.c"
				goto __catch0_g_file_error;
			}
#line 319 "../src/daemon/Server.vala"
			_g_free0 (contents);
#line 319 "../src/daemon/Server.vala"
			_g_free0 (path);
#line 319 "../src/daemon/Server.vala"
			config_dirs = (g_free (config_dirs), NULL);
#line 319 "../src/daemon/Server.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 319 "../src/daemon/Server.vala"
			g_clear_error (&_inner_error0_);
#line 319 "../src/daemon/Server.vala"
			return;
#line 2426 "Server.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 318 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 318 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 321 "../src/daemon/Server.vala"
		_tmp14_ = e;
#line 321 "../src/daemon/Server.vala"
		_tmp15_ = _tmp14_->message;
#line 321 "../src/daemon/Server.vala"
		g_warning ("Server.vala:321: %s", _tmp15_);
#line 322 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 322 "../src/daemon/Server.vala"
		_g_free0 (contents);
#line 322 "../src/daemon/Server.vala"
		_g_free0 (path);
#line 322 "../src/daemon/Server.vala"
		config_dirs = (g_free (config_dirs), NULL);
#line 322 "../src/daemon/Server.vala"
		return;
#line 2455 "Server.c"
	}
	__finally0:
#line 318 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "../src/daemon/Server.vala"
		_g_free0 (contents);
#line 318 "../src/daemon/Server.vala"
		_g_free0 (path);
#line 318 "../src/daemon/Server.vala"
		config_dirs = (g_free (config_dirs), NULL);
#line 318 "../src/daemon/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 318 "../src/daemon/Server.vala"
		g_clear_error (&_inner_error0_);
#line 318 "../src/daemon/Server.vala"
		return;
#line 2472 "Server.c"
	}
#line 325 "../src/daemon/Server.vala"
	_tmp16_ = g_strdup ("\naccount required pam_time.so");
#line 325 "../src/daemon/Server.vala"
	conf_line = _tmp16_;
#line 326 "../src/daemon/Server.vala"
	_tmp17_ = contents;
#line 326 "../src/daemon/Server.vala"
	_tmp18_ = conf_line;
#line 326 "../src/daemon/Server.vala"
	if (string_contains (_tmp17_, _tmp18_)) {
#line 327 "../src/daemon/Server.vala"
		_g_free0 (conf_line);
#line 327 "../src/daemon/Server.vala"
		_g_free0 (contents);
#line 327 "../src/daemon/Server.vala"
		_g_free0 (path);
#line 327 "../src/daemon/Server.vala"
		config_dirs = (g_free (config_dirs), NULL);
#line 327 "../src/daemon/Server.vala"
		return;
#line 2494 "Server.c"
	}
#line 330 "../src/daemon/Server.vala"
	_tmp19_ = contents;
#line 330 "../src/daemon/Server.vala"
	_tmp20_ = conf_line;
#line 330 "../src/daemon/Server.vala"
	_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
#line 330 "../src/daemon/Server.vala"
	_g_free0 (contents);
#line 330 "../src/daemon/Server.vala"
	contents = _tmp21_;
#line 2506 "Server.c"
	{
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 333 "../src/daemon/Server.vala"
		_tmp22_ = path;
#line 333 "../src/daemon/Server.vala"
		_tmp23_ = contents;
#line 333 "../src/daemon/Server.vala"
		g_file_set_contents (_tmp22_, _tmp23_, (gssize) -1, &_inner_error0_);
#line 333 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 333 "../src/daemon/Server.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2520 "Server.c"
				goto __catch1_g_file_error;
			}
#line 333 "../src/daemon/Server.vala"
			_g_free0 (conf_line);
#line 333 "../src/daemon/Server.vala"
			_g_free0 (contents);
#line 333 "../src/daemon/Server.vala"
			_g_free0 (path);
#line 333 "../src/daemon/Server.vala"
			config_dirs = (g_free (config_dirs), NULL);
#line 333 "../src/daemon/Server.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 333 "../src/daemon/Server.vala"
			g_clear_error (&_inner_error0_);
#line 333 "../src/daemon/Server.vala"
			return;
#line 2537 "Server.c"
		}
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 332 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 332 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 335 "../src/daemon/Server.vala"
		_tmp24_ = e;
#line 335 "../src/daemon/Server.vala"
		_tmp25_ = _tmp24_->message;
#line 335 "../src/daemon/Server.vala"
		g_warning ("Server.vala:335: %s\n", _tmp25_);
#line 332 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 2558 "Server.c"
	}
	__finally1:
#line 332 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "../src/daemon/Server.vala"
		_g_free0 (conf_line);
#line 332 "../src/daemon/Server.vala"
		_g_free0 (contents);
#line 332 "../src/daemon/Server.vala"
		_g_free0 (path);
#line 332 "../src/daemon/Server.vala"
		config_dirs = (g_free (config_dirs), NULL);
#line 332 "../src/daemon/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 332 "../src/daemon/Server.vala"
		g_clear_error (&_inner_error0_);
#line 332 "../src/daemon/Server.vala"
		return;
#line 2577 "Server.c"
	}
#line 296 "../src/daemon/Server.vala"
	_g_free0 (conf_line);
#line 296 "../src/daemon/Server.vala"
	_g_free0 (contents);
#line 296 "../src/daemon/Server.vala"
	_g_free0 (path);
#line 296 "../src/daemon/Server.vala"
	config_dirs = (g_free (config_dirs), NULL);
#line 2587 "Server.c"
}

static gboolean
pc_daemon_server_get_sender_is_authorized (PCDaemonServer* self,
                                           const char* sender,
                                           GError** error)
{
	PCDaemonDBus* _tmp0_;
	guint32 user = 0U;
	guint32 pid = 0U;
	PolkitUnixProcess* subject = NULL;
	PolkitUnixProcess* _tmp10_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 339 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 339 "../src/daemon/Server.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 340 "../src/daemon/Server.vala"
	_tmp0_ = self->priv->bus_proxy;
#line 340 "../src/daemon/Server.vala"
	if (_tmp0_ == NULL) {
#line 2610 "Server.c"
		GError* _tmp1_;
#line 341 "../src/daemon/Server.vala"
		_tmp1_ = g_error_new_literal (PC_DAEMON_PARENTAL_CONTROLS_ERROR, PC_DAEMON_PARENTAL_CONTROLS_ERROR_DBUS_CONNECTION_FAILED, "Error: connecting to org.freedesktop.DBus failed.");
#line 341 "../src/daemon/Server.vala"
		_inner_error0_ = _tmp1_;
#line 341 "../src/daemon/Server.vala"
		if (_inner_error0_->domain == PC_DAEMON_PARENTAL_CONTROLS_ERROR) {
#line 2618 "Server.c"
			gboolean _tmp2_ = FALSE;
#line 341 "../src/daemon/Server.vala"
			g_propagate_error (error, _inner_error0_);
#line 341 "../src/daemon/Server.vala"
			return _tmp2_;
#line 2624 "Server.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 341 "../src/daemon/Server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "../src/daemon/Server.vala"
			g_clear_error (&_inner_error0_);
#line 341 "../src/daemon/Server.vala"
			return _tmp3_;
#line 2633 "Server.c"
		}
	}
#line 346 "../src/daemon/Server.vala"
	user = (guint32) 0;
#line 346 "../src/daemon/Server.vala"
	pid = (guint32) 0;
#line 2640 "Server.c"
	{
		guint32 _tmp4_ = 0U;
		PCDaemonDBus* _tmp5_;
#line 349 "../src/daemon/Server.vala"
		pid = pc_daemon_server_get_pid_from_sender (self, sender);
#line 350 "../src/daemon/Server.vala"
		_tmp5_ = self->priv->bus_proxy;
#line 350 "../src/daemon/Server.vala"
		_tmp4_ = pc_daemon_dbus_get_connection_unix_user (_tmp5_, (const gchar*) sender, &_inner_error0_);
#line 350 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2652 "Server.c"
			goto __catch0_g_error;
		}
#line 350 "../src/daemon/Server.vala"
		user = _tmp4_;
#line 2657 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 348 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 348 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 352 "../src/daemon/Server.vala"
		_tmp6_ = e;
#line 352 "../src/daemon/Server.vala"
		_tmp7_ = _tmp6_->message;
#line 352 "../src/daemon/Server.vala"
		g_warning ("Server.vala:352: %s", _tmp7_);
#line 348 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 2677 "Server.c"
	}
	__finally0:
#line 348 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "../src/daemon/Server.vala"
		if (_inner_error0_->domain == PC_DAEMON_PARENTAL_CONTROLS_ERROR) {
#line 2684 "Server.c"
			gboolean _tmp8_ = FALSE;
#line 348 "../src/daemon/Server.vala"
			g_propagate_error (error, _inner_error0_);
#line 348 "../src/daemon/Server.vala"
			return _tmp8_;
#line 2690 "Server.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 348 "../src/daemon/Server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../src/daemon/Server.vala"
			g_clear_error (&_inner_error0_);
#line 348 "../src/daemon/Server.vala"
			return _tmp9_;
#line 2699 "Server.c"
		}
	}
#line 355 "../src/daemon/Server.vala"
	_tmp10_ = (PolkitUnixProcess*) polkit_unix_process_new_for_owner ((gint) pid, (guint64) 0, (gint) user);
#line 355 "../src/daemon/Server.vala"
	subject = _tmp10_;
#line 2706 "Server.c"
	{
		PolkitAuthority* authority = NULL;
		PolkitAuthority* _tmp11_;
		PolkitAuthorizationResult* auth_result = NULL;
		PolkitAuthority* _tmp12_;
		PolkitUnixProcess* _tmp13_;
		PolkitAuthorizationResult* _tmp14_;
		PolkitAuthorizationResult* _tmp15_;
#line 358 "../src/daemon/Server.vala"
		_tmp11_ = polkit_authority_get_sync (NULL, &_inner_error0_);
#line 358 "../src/daemon/Server.vala"
		authority = _tmp11_;
#line 358 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2721 "Server.c"
			goto __catch1_g_error;
		}
#line 359 "../src/daemon/Server.vala"
		_tmp12_ = authority;
#line 359 "../src/daemon/Server.vala"
		_tmp13_ = subject;
#line 359 "../src/daemon/Server.vala"
		_tmp14_ = polkit_authority_check_authorization_sync (_tmp12_, (PolkitSubject*) _tmp13_, PC_CONSTANTS_PARENTAL_CONTROLS_ACTION_ID, NULL, POLKIT_CHECK_AUTHORIZATION_FLAGS_NONE, NULL, &_inner_error0_);
#line 359 "../src/daemon/Server.vala"
		auth_result = _tmp14_;
#line 359 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../src/daemon/Server.vala"
			_g_object_unref0 (authority);
#line 2736 "Server.c"
			goto __catch1_g_error;
		}
#line 365 "../src/daemon/Server.vala"
		_tmp15_ = auth_result;
#line 365 "../src/daemon/Server.vala"
		result = polkit_authorization_result_get_is_authorized (_tmp15_);
#line 365 "../src/daemon/Server.vala"
		_g_object_unref0 (auth_result);
#line 365 "../src/daemon/Server.vala"
		_g_object_unref0 (authority);
#line 365 "../src/daemon/Server.vala"
		_g_object_unref0 (subject);
#line 365 "../src/daemon/Server.vala"
		return result;
#line 2751 "Server.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 357 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 357 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 367 "../src/daemon/Server.vala"
		_tmp16_ = e;
#line 367 "../src/daemon/Server.vala"
		_tmp17_ = _tmp16_->message;
#line 367 "../src/daemon/Server.vala"
		g_warning ("Server.vala:367: %s", _tmp17_);
#line 357 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 2771 "Server.c"
	}
	__finally1:
#line 357 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 357 "../src/daemon/Server.vala"
		if (_inner_error0_->domain == PC_DAEMON_PARENTAL_CONTROLS_ERROR) {
#line 2778 "Server.c"
			gboolean _tmp18_ = FALSE;
#line 357 "../src/daemon/Server.vala"
			g_propagate_error (error, _inner_error0_);
#line 357 "../src/daemon/Server.vala"
			_g_object_unref0 (subject);
#line 357 "../src/daemon/Server.vala"
			return _tmp18_;
#line 2786 "Server.c"
		} else {
			gboolean _tmp19_ = FALSE;
#line 357 "../src/daemon/Server.vala"
			_g_object_unref0 (subject);
#line 357 "../src/daemon/Server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 357 "../src/daemon/Server.vala"
			g_clear_error (&_inner_error0_);
#line 357 "../src/daemon/Server.vala"
			return _tmp19_;
#line 2797 "Server.c"
		}
	}
#line 370 "../src/daemon/Server.vala"
	result = FALSE;
#line 370 "../src/daemon/Server.vala"
	_g_object_unref0 (subject);
#line 370 "../src/daemon/Server.vala"
	return result;
#line 2806 "Server.c"
}

static guint32
pc_daemon_server_get_pid_from_sender (PCDaemonServer* self,
                                      const char* sender)
{
	guint32 pid = 0U;
	GError* _inner_error0_ = NULL;
	guint32 result;
#line 373 "../src/daemon/Server.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 373 "../src/daemon/Server.vala"
	g_return_val_if_fail (sender != NULL, 0U);
#line 374 "../src/daemon/Server.vala"
	pid = (guint32) 0;
#line 2822 "Server.c"
	{
		guint32 _tmp0_ = 0U;
		PCDaemonDBus* _tmp1_;
#line 377 "../src/daemon/Server.vala"
		_tmp1_ = self->priv->bus_proxy;
#line 377 "../src/daemon/Server.vala"
		_tmp0_ = pc_daemon_dbus_get_connection_unix_process_id (_tmp1_, (const gchar*) sender, &_inner_error0_);
#line 377 "../src/daemon/Server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2832 "Server.c"
			goto __catch0_g_error;
		}
#line 377 "../src/daemon/Server.vala"
		pid = _tmp0_;
#line 2837 "Server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 376 "../src/daemon/Server.vala"
		e = _inner_error0_;
#line 376 "../src/daemon/Server.vala"
		_inner_error0_ = NULL;
#line 379 "../src/daemon/Server.vala"
		_tmp2_ = e;
#line 379 "../src/daemon/Server.vala"
		_tmp3_ = _tmp2_->message;
#line 379 "../src/daemon/Server.vala"
		g_warning ("Server.vala:379: %s", _tmp3_);
#line 376 "../src/daemon/Server.vala"
		_g_error_free0 (e);
#line 2857 "Server.c"
	}
	__finally0:
#line 376 "../src/daemon/Server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2862 "Server.c"
		guint32 _tmp4_ = 0U;
#line 376 "../src/daemon/Server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 376 "../src/daemon/Server.vala"
		g_clear_error (&_inner_error0_);
#line 376 "../src/daemon/Server.vala"
		return _tmp4_;
#line 2870 "Server.c"
	}
#line 382 "../src/daemon/Server.vala"
	result = pid;
#line 382 "../src/daemon/Server.vala"
	return result;
#line 2876 "Server.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_INT_BOOLEAN (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_INT_BOOLEAN) (gpointer data1, gpointer arg_1, gint arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__BOXED_INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 40 "../src/daemon/Server.vala"
	g_return_if_fail (n_param_values == 4);
#line 40 "../src/daemon/Server.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 40 "../src/daemon/Server.vala"
		data1 = closure->data;
#line 40 "../src/daemon/Server.vala"
		data2 = param_values->data[0].v_pointer;
#line 2901 "Server.c"
	} else {
#line 40 "../src/daemon/Server.vala"
		data1 = param_values->data[0].v_pointer;
#line 40 "../src/daemon/Server.vala"
		data2 = closure->data;
#line 2907 "Server.c"
	}
#line 40 "../src/daemon/Server.vala"
	callback = (GMarshalFunc_VOID__BOXED_INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 40 "../src/daemon/Server.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_int (param_values + 2), g_value_get_boolean (param_values + 3), data2);
#line 2913 "Server.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 40 "../src/daemon/Server.vala"
	g_return_if_fail (n_param_values == 3);
#line 40 "../src/daemon/Server.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 40 "../src/daemon/Server.vala"
		data1 = closure->data;
#line 40 "../src/daemon/Server.vala"
		data2 = param_values->data[0].v_pointer;
#line 2938 "Server.c"
	} else {
#line 40 "../src/daemon/Server.vala"
		data1 = param_values->data[0].v_pointer;
#line 40 "../src/daemon/Server.vala"
		data2 = closure->data;
#line 2944 "Server.c"
	}
#line 40 "../src/daemon/Server.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 40 "../src/daemon/Server.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2950 "Server.c"
}

static void
pc_daemon_server_class_init (PCDaemonServerClass * klass,
                             gpointer klass_data)
{
#line 40 "../src/daemon/Server.vala"
	pc_daemon_server_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/daemon/Server.vala"
	g_type_class_adjust_private_offset (klass, &PCDaemonServer_private_offset);
#line 40 "../src/daemon/Server.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_daemon_server_finalize;
#line 40 "../src/daemon/Server.vala"
	pc_daemon_server_signals[PC_DAEMON_SERVER_LAUNCH_SIGNAL] = g_signal_new ("launch", PC_DAEMON_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_INT_BOOLEAN, G_TYPE_NONE, 3, G_TYPE_STRV, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 40 "../src/daemon/Server.vala"
	pc_daemon_server_signals[PC_DAEMON_SERVER_SHOW_TIMEOUT_SIGNAL] = g_signal_new ("show-timeout", PC_DAEMON_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 40 "../src/daemon/Server.vala"
	pc_daemon_server_signals[PC_DAEMON_SERVER_CONFIG_CHANGED_SIGNAL] = g_signal_new ("config-changed", PC_DAEMON_TYPE_SERVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2969 "Server.c"
}

static void
pc_daemon_server_instance_init (PCDaemonServer * self,
                                gpointer klass)
{
#line 40 "../src/daemon/Server.vala"
	self->priv = pc_daemon_server_get_instance_private (self);
#line 44 "../src/daemon/Server.vala"
	self->priv->bus_proxy = NULL;
#line 2980 "Server.c"
}

static void
pc_daemon_server_finalize (GObject * obj)
{
	PCDaemonServer * self;
#line 40 "../src/daemon/Server.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_DAEMON_TYPE_SERVER, PCDaemonServer);
#line 44 "../src/daemon/Server.vala"
	_g_object_unref0 (self->priv->bus_proxy);
#line 40 "../src/daemon/Server.vala"
	G_OBJECT_CLASS (pc_daemon_server_parent_class)->finalize (obj);
#line 2993 "Server.c"
}

static GType
pc_daemon_server_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCDaemonServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_daemon_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCDaemonServer), 0, (GInstanceInitFunc) pc_daemon_server_instance_init, NULL };
	GType pc_daemon_server_type_id;
	pc_daemon_server_type_id = g_type_register_static (G_TYPE_OBJECT, "PCDaemonServer", &g_define_type_info, 0);
	g_type_set_qdata (pc_daemon_server_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) pc_daemon_server_register_object);
	PCDaemonServer_private_offset = g_type_add_instance_private (pc_daemon_server_type_id, sizeof (PCDaemonServerPrivate));
	return pc_daemon_server_type_id;
}

GType
pc_daemon_server_get_type (void)
{
	static volatile gsize pc_daemon_server_type_id__once = 0;
	if (g_once_init_enter (&pc_daemon_server_type_id__once)) {
		GType pc_daemon_server_type_id;
		pc_daemon_server_type_id = pc_daemon_server_get_type_once ();
		g_once_init_leave (&pc_daemon_server_type_id__once, pc_daemon_server_type_id);
	}
	return pc_daemon_server_type_id__once;
}

static void
_dbus_pc_daemon_server_finish_app_authorization (PCDaemonServer* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp8_;
	gchar** args = NULL;
	gint args_length1 = 0;
	GVariant* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length;
	gint _tmp10__size;
	gint _tmp10__length1;
	GVariantIter _tmp11_;
	GVariant* _tmp12_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp10_ = g_new (gchar*, 5);
	_tmp10__length = 0;
	_tmp10__size = 4;
	_tmp10__length1 = 0;
	g_variant_iter_init (&_tmp11_, _tmp9_);
	for (; (_tmp12_ = g_variant_iter_next_value (&_tmp11_)) != NULL; _tmp10__length1++) {
		if (_tmp10__size == _tmp10__length) {
			_tmp10__size = 2 * _tmp10__size;
			_tmp10_ = g_renew (gchar*, _tmp10_, _tmp10__size + 1);
		}
		_tmp10_[_tmp10__length++] = g_variant_dup_string (_tmp12_, NULL);
		g_variant_unref (_tmp12_);
	}
	args_length1 = _tmp10__length1;
	_tmp10_[_tmp10__length] = NULL;
	args = _tmp10_;
	g_variant_unref (_tmp9_);
	pc_daemon_server_finish_app_authorization (self, g_dbus_method_invocation_get_sender (invocation), username, args, args_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pc_daemon_server_add_restriction_for_user (PCDaemonServer* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* input = NULL;
	GVariant* _tmp13_;
	gboolean clean = FALSE;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	input = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	clean = g_variant_get_boolean (_tmp14_);
	g_variant_unref (_tmp14_);
	pc_daemon_server_add_restriction_for_user (self, input, clean, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (input);
	;
}

static void
_dbus_pc_daemon_server_remove_restriction_for_user (PCDaemonServer* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp15_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	pc_daemon_server_remove_restriction_for_user (self, username, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_lock_dock_icons_for_user (PCDaemonServer* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp16_;
	gboolean lock = FALSE;
	GVariant* _tmp17_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	lock = g_variant_get_boolean (_tmp17_);
	g_variant_unref (_tmp17_);
	pc_daemon_server_lock_dock_icons_for_user (self, username, lock, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_set_user_daemon_active (PCDaemonServer* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp18_;
	gboolean active = FALSE;
	GVariant* _tmp19_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	active = g_variant_get_boolean (_tmp19_);
	g_variant_unref (_tmp19_);
	pc_daemon_server_set_user_daemon_active (self, username, active, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_set_user_daemon_targets (PCDaemonServer* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp20_;
	gchar** targets = NULL;
	gint targets_length1 = 0;
	GVariant* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length;
	gint _tmp22__size;
	gint _tmp22__length1;
	GVariantIter _tmp23_;
	GVariant* _tmp24_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp22_ = g_new (gchar*, 5);
	_tmp22__length = 0;
	_tmp22__size = 4;
	_tmp22__length1 = 0;
	g_variant_iter_init (&_tmp23_, _tmp21_);
	for (; (_tmp24_ = g_variant_iter_next_value (&_tmp23_)) != NULL; _tmp22__length1++) {
		if (_tmp22__size == _tmp22__length) {
			_tmp22__size = 2 * _tmp22__size;
			_tmp22_ = g_renew (gchar*, _tmp22_, _tmp22__size + 1);
		}
		_tmp22_[_tmp22__length++] = g_variant_dup_string (_tmp24_, NULL);
		g_variant_unref (_tmp24_);
	}
	targets_length1 = _tmp22__length1;
	_tmp22_[_tmp22__length] = NULL;
	targets = _tmp22_;
	g_variant_unref (_tmp21_);
	pc_daemon_server_set_user_daemon_targets (self, username, targets, targets_length1, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	targets = (_vala_array_free (targets, targets_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pc_daemon_server_set_user_daemon_block_urls (PCDaemonServer* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp25_;
	gchar** block_urls = NULL;
	gint block_urls_length1 = 0;
	GVariant* _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length;
	gint _tmp27__size;
	gint _tmp27__length1;
	GVariantIter _tmp28_;
	GVariant* _tmp29_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp25_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp25_, NULL);
	g_variant_unref (_tmp25_);
	_tmp26_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp27_ = g_new (gchar*, 5);
	_tmp27__length = 0;
	_tmp27__size = 4;
	_tmp27__length1 = 0;
	g_variant_iter_init (&_tmp28_, _tmp26_);
	for (; (_tmp29_ = g_variant_iter_next_value (&_tmp28_)) != NULL; _tmp27__length1++) {
		if (_tmp27__size == _tmp27__length) {
			_tmp27__size = 2 * _tmp27__size;
			_tmp27_ = g_renew (gchar*, _tmp27_, _tmp27__size + 1);
		}
		_tmp27_[_tmp27__length++] = g_variant_dup_string (_tmp29_, NULL);
		g_variant_unref (_tmp29_);
	}
	block_urls_length1 = _tmp27__length1;
	_tmp27_[_tmp27__length] = NULL;
	block_urls = _tmp27_;
	g_variant_unref (_tmp26_);
	pc_daemon_server_set_user_daemon_block_urls (self, username, block_urls, block_urls_length1, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	block_urls = (_vala_array_free (block_urls, block_urls_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_pc_daemon_server_set_user_daemon_admin (PCDaemonServer* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp30_;
	gboolean admin = FALSE;
	GVariant* _tmp31_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp30_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp30_, NULL);
	g_variant_unref (_tmp30_);
	_tmp31_ = g_variant_iter_next_value (&_arguments_iter);
	admin = g_variant_get_boolean (_tmp31_);
	g_variant_unref (_tmp31_);
	pc_daemon_server_set_user_daemon_admin (self, username, admin, g_dbus_method_invocation_get_sender (invocation), &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_get_user_daemon_active (PCDaemonServer* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp32_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp32_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp32_, NULL);
	g_variant_unref (_tmp32_);
	result = pc_daemon_server_get_user_daemon_active (self, username, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_get_user_daemon_targets (PCDaemonServer* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp33_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp34_;
	GVariantBuilder _tmp35_;
	gint _tmp36_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp33_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp33_, NULL);
	g_variant_unref (_tmp33_);
	result = pc_daemon_server_get_user_daemon_targets (self, username, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp34_ = result;
	g_variant_builder_init (&_tmp35_, G_VARIANT_TYPE ("as"));
	for (_tmp36_ = 0; _tmp36_ < result_length1; _tmp36_++) {
		g_variant_builder_add_value (&_tmp35_, g_variant_new_string (*_tmp34_));
		_tmp34_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp35_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_get_user_daemon_block_urls (PCDaemonServer* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp37_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	gint result_length1 = 0;
	gchar** _tmp38_;
	GVariantBuilder _tmp39_;
	gint _tmp40_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp37_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp37_, NULL);
	g_variant_unref (_tmp37_);
	result = pc_daemon_server_get_user_daemon_block_urls (self, username, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp38_ = result;
	g_variant_builder_init (&_tmp39_, G_VARIANT_TYPE ("as"));
	for (_tmp40_ = 0; _tmp40_ < result_length1; _tmp40_++) {
		g_variant_builder_add_value (&_tmp39_, g_variant_new_string (*_tmp38_));
		_tmp38_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp39_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
_dbus_pc_daemon_server_get_user_daemon_admin (PCDaemonServer* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* username = NULL;
	GVariant* _tmp41_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp41_ = g_variant_iter_next_value (&_arguments_iter);
	username = g_variant_dup_string (_tmp41_, NULL);
	g_variant_unref (_tmp41_);
	result = pc_daemon_server_get_user_daemon_admin (self, username, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (username);
	;
}

static void
pc_daemon_server_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "FinishAppAuthorization") == 0) {
		_dbus_pc_daemon_server_finish_app_authorization (object, parameters, invocation);
	} else if (strcmp (method_name, "AddRestrictionForUser") == 0) {
		_dbus_pc_daemon_server_add_restriction_for_user (object, parameters, invocation);
	} else if (strcmp (method_name, "RemoveRestrictionForUser") == 0) {
		_dbus_pc_daemon_server_remove_restriction_for_user (object, parameters, invocation);
	} else if (strcmp (method_name, "LockDockIconsForUser") == 0) {
		_dbus_pc_daemon_server_lock_dock_icons_for_user (object, parameters, invocation);
	} else if (strcmp (method_name, "SetUserDaemonActive") == 0) {
		_dbus_pc_daemon_server_set_user_daemon_active (object, parameters, invocation);
	} else if (strcmp (method_name, "SetUserDaemonTargets") == 0) {
		_dbus_pc_daemon_server_set_user_daemon_targets (object, parameters, invocation);
	} else if (strcmp (method_name, "SetUserDaemonBlockUrls") == 0) {
		_dbus_pc_daemon_server_set_user_daemon_block_urls (object, parameters, invocation);
	} else if (strcmp (method_name, "SetUserDaemonAdmin") == 0) {
		_dbus_pc_daemon_server_set_user_daemon_admin (object, parameters, invocation);
	} else if (strcmp (method_name, "GetUserDaemonActive") == 0) {
		_dbus_pc_daemon_server_get_user_daemon_active (object, parameters, invocation);
	} else if (strcmp (method_name, "GetUserDaemonTargets") == 0) {
		_dbus_pc_daemon_server_get_user_daemon_targets (object, parameters, invocation);
	} else if (strcmp (method_name, "GetUserDaemonBlockUrls") == 0) {
		_dbus_pc_daemon_server_get_user_daemon_block_urls (object, parameters, invocation);
	} else if (strcmp (method_name, "GetUserDaemonAdmin") == 0) {
		_dbus_pc_daemon_server_get_user_daemon_admin (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
pc_daemon_server_dbus_interface_get_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
pc_daemon_server_dbus_interface_set_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GVariant* value,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_pc_daemon_server_launch (GObject* _sender,
                               gchar** args,
                               gint args_length1,
                               gboolean incoming,
                               gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp42_;
	GVariantBuilder _tmp43_;
	gint _tmp44_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp42_ = args;
	g_variant_builder_init (&_tmp43_, G_VARIANT_TYPE ("as"));
	for (_tmp44_ = 0; _tmp44_ < args_length1; _tmp44_++) {
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string (*_tmp42_));
		_tmp42_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp43_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (incoming));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.pantheon.ParentalControls", "Launch", _arguments, NULL);
}

static void
_dbus_pc_daemon_server_show_timeout (GObject* _sender,
                                     gint hours,
                                     gint minutes,
                                     gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (hours));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (minutes));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.pantheon.ParentalControls", "ShowTimeout", _arguments, NULL);
}

static void
_dbus_pc_daemon_server_config_changed (GObject* _sender,
                                       gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.pantheon.ParentalControls", "ConfigChanged", _arguments, NULL);
}

guint
pc_daemon_server_register_object (gpointer object,
                                  GDBusConnection* connection,
                                  const gchar* path,
                                  GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_pc_daemon_server_dbus_interface_info), &_pc_daemon_server_dbus_interface_vtable, data, _pc_daemon_server_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "launch", (GCallback) _dbus_pc_daemon_server_launch, data);
	g_signal_connect (object, "show-timeout", (GCallback) _dbus_pc_daemon_server_show_timeout, data);
	g_signal_connect (object, "config-changed", (GCallback) _dbus_pc_daemon_server_config_changed, data);
	return result;
}

static void
_pc_daemon_server_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pc_daemon_server_launch, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pc_daemon_server_show_timeout, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_pc_daemon_server_config_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

