/* InternetView.c generated by valac 0.56.17, the Vala compiler
 * generated from InternetView.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
 *                         2015 Adam Bieńkowski
 */

#include "screentime-limits.h"
#include <act/act.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <granite-7.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <polkit/polkit.h>
#include <glib/gi18n-lib.h>

#define PC_WIDGETS_INTERNET_BOX_URL_REGEX "[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-z]{2,4}\\b([-a-zA-Z0-9@:%_\\+.~#?&" \
"//=]*)"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PC_WIDGETS_INTERNET_BOX_0_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_USER_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_NUM_PROPERTIES];
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PcWidgetsInternetBoxLoadExistingData PcWidgetsInternetBoxLoadExistingData;

#define PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY (pc_widgets_internet_box_url_entry_get_type ())
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry))
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntryClass))
#define PC_WIDGETS_INTERNET_BOX_IS_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY))
#define PC_WIDGETS_INTERNET_BOX_IS_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY))
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntryClass))

typedef struct _PCWidgetsInternetBoxUrlEntry PCWidgetsInternetBoxUrlEntry;
typedef struct _PCWidgetsInternetBoxUrlEntryClass PCWidgetsInternetBoxUrlEntryClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PCWidgetsInternetBoxUrlEntryPrivate PCWidgetsInternetBoxUrlEntryPrivate;
enum  {
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_0_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_NUM_PROPERTIES];

struct _PCWidgetsInternetBoxPrivate {
	ActUser* _user;
	GRegex* url_regex;
	GtkListBox* list_box;
	GraniteValidatedEntry* entry;
	GtkButton* add_button;
};

struct _PcWidgetsInternetBoxLoadExistingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PCWidgetsInternetBox* self;
	gchar** block_urls;
	PCIParentalControls* _tmp0_;
	ActUser* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gchar** _tmp4_;
	gint block_urls_length1;
	gint _block_urls_size_;
	gchar** url_collection;
	gint url_collection_length1;
	gint _url_collection_size_;
	gint url_it;
	const gchar* url;
	const gchar* _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _PCWidgetsInternetBoxUrlEntry {
	GtkListBoxRow parent_instance;
	PCWidgetsInternetBoxUrlEntryPrivate * priv;
};

struct _PCWidgetsInternetBoxUrlEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _PCWidgetsInternetBoxUrlEntryPrivate {
	gchar* _url;
};

static gint PCWidgetsInternetBox_private_offset;
static gpointer pc_widgets_internet_box_parent_class = NULL;
static gint PCWidgetsInternetBoxUrlEntry_private_offset;
static gpointer pc_widgets_internet_box_url_entry_parent_class = NULL;

static void pc_widgets_internet_box_load_existing_data_free (gpointer _data);
static void pc_widgets_internet_box_load_existing (PCWidgetsInternetBox* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void pc_widgets_internet_box_load_existing_finish (PCWidgetsInternetBox* self,
                                                   GAsyncResult* _res_);
static gboolean pc_widgets_internet_box_load_existing_co (PcWidgetsInternetBoxLoadExistingData* _data_);
static void pc_widgets_internet_box_load_existing_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void pc_widgets_internet_box_add_entry (PCWidgetsInternetBox* self,
                                        const gchar* url);
static void pc_widgets_internet_box_update_block_urls (PCWidgetsInternetBox* self);
static GType pc_widgets_internet_box_url_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static const gchar* pc_widgets_internet_box_url_entry_get_url (PCWidgetsInternetBoxUrlEntry* self);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void pc_widgets_internet_box_on_entry_activate (PCWidgetsInternetBox* self);
static PCWidgetsInternetBoxUrlEntry* pc_widgets_internet_box_url_entry_new (const gchar* url);
static PCWidgetsInternetBoxUrlEntry* pc_widgets_internet_box_url_entry_construct (GType object_type,
                                                                           const gchar* url);
static void __lambda15_ (PCWidgetsInternetBox* self);
static void ___lambda15__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static void pc_widgets_internet_box_url_entry_set_url (PCWidgetsInternetBoxUrlEntry* self,
                                                const gchar* value);
static GObject * pc_widgets_internet_box_url_entry_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void _pc_widgets_internet_box_url_entry___lambda14_ (PCWidgetsInternetBoxUrlEntry* self);
static void __pc_widgets_internet_box_url_entry___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void pc_widgets_internet_box_url_entry_finalize (GObject * obj);
static GType pc_widgets_internet_box_url_entry_get_type_once (void);
static void _vala_pc_widgets_internet_box_url_entry_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_pc_widgets_internet_box_url_entry_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static GObject * pc_widgets_internet_box_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _pc_widgets_internet_box_on_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _pc_widgets_internet_box___lambda16_ (PCWidgetsInternetBox* self);
static void __pc_widgets_internet_box___lambda16__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _pc_widgets_internet_box_on_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                    gpointer self);
static void pc_widgets_internet_box_finalize (GObject * obj);
static GType pc_widgets_internet_box_get_type_once (void);
static void _vala_pc_widgets_internet_box_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_pc_widgets_internet_box_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
pc_widgets_internet_box_get_instance_private (PCWidgetsInternetBox* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsInternetBox_private_offset);
}

PCWidgetsInternetBox*
pc_widgets_internet_box_construct (GType object_type,
                                   ActUser* user)
{
	PCWidgetsInternetBox * self = NULL;
#line 17 "../src/plug/Views/InternetView.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 18 "../src/plug/Views/InternetView.vala"
	self = (PCWidgetsInternetBox*) g_object_new (object_type, "user", user, NULL);
#line 17 "../src/plug/Views/InternetView.vala"
	return self;
#line 203 "InternetView.c"
}

PCWidgetsInternetBox*
pc_widgets_internet_box_new (ActUser* user)
{
#line 17 "../src/plug/Views/InternetView.vala"
	return pc_widgets_internet_box_construct (PC_WIDGETS_TYPE_INTERNET_BOX, user);
#line 211 "InternetView.c"
}

static void
pc_widgets_internet_box_load_existing_data_free (gpointer _data)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	_data_ = _data;
#line 7 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (_data_->self);
#line 7 "../src/plug/Views/InternetView.vala"
	g_slice_free (PcWidgetsInternetBoxLoadExistingData, _data_);
#line 223 "InternetView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 7 "../src/plug/Views/InternetView.vala"
	return self ? g_object_ref (self) : NULL;
#line 231 "InternetView.c"
}

static void
pc_widgets_internet_box_load_existing (PCWidgetsInternetBox* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	PCWidgetsInternetBox* _tmp0_;
#line 7 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 7 "../src/plug/Views/InternetView.vala"
	_data_ = g_slice_new0 (PcWidgetsInternetBoxLoadExistingData);
#line 7 "../src/plug/Views/InternetView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 7 "../src/plug/Views/InternetView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, pc_widgets_internet_box_load_existing_data_free);
#line 7 "../src/plug/Views/InternetView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 7 "../src/plug/Views/InternetView.vala"
	_data_->self = _tmp0_;
#line 7 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_load_existing_co (_data_);
#line 255 "InternetView.c"
}

static void
pc_widgets_internet_box_load_existing_finish (PCWidgetsInternetBox* self,
                                              GAsyncResult* _res_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
#line 7 "../src/plug/Views/InternetView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 265 "InternetView.c"
}

static void
pc_widgets_internet_box_load_existing_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
#line 87 "../src/plug/Views/InternetView.vala"
	_data_ = _user_data_;
#line 87 "../src/plug/Views/InternetView.vala"
	_data_->_source_object_ = source_object;
#line 87 "../src/plug/Views/InternetView.vala"
	_data_->_res_ = _res_;
#line 87 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_load_existing_co (_data_);
#line 282 "InternetView.c"
}

static gboolean
pc_widgets_internet_box_load_existing_co (PcWidgetsInternetBoxLoadExistingData* _data_)
{
#line 85 "../src/plug/Views/InternetView.vala"
	switch (_data_->_state_) {
#line 85 "../src/plug/Views/InternetView.vala"
		case 0:
#line 292 "InternetView.c"
		goto _state_0;
#line 85 "../src/plug/Views/InternetView.vala"
		case 1:
#line 296 "InternetView.c"
		goto _state_1;
		default:
#line 85 "../src/plug/Views/InternetView.vala"
		g_assert_not_reached ();
#line 301 "InternetView.c"
	}
	_state_0:
	{
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_tmp0_ = pc_utils_get_api ();
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_tmp1_ = _data_->self->priv->_user;
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_tmp2_ = act_user_get_user_name (_data_->_tmp1_);
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_tmp3_ = 0;
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_state_ = 1;
#line 87 "../src/plug/Views/InternetView.vala"
		pc_iparental_controls_get_user_daemon_block_urls (_data_->_tmp0_, _data_->_tmp2_, pc_widgets_internet_box_load_existing_ready, _data_);
#line 87 "../src/plug/Views/InternetView.vala"
		return FALSE;
#line 319 "InternetView.c"
		_state_1:
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_tmp4_ = pc_iparental_controls_get_user_daemon_block_urls_finish (_data_->_tmp0_, _data_->_res_, &_data_->_tmp3_, &_data_->_inner_error0_);
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->block_urls = _data_->_tmp4_;
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->block_urls_length1 = _data_->_tmp3_;
#line 87 "../src/plug/Views/InternetView.vala"
		_data_->_block_urls_size_ = _data_->block_urls_length1;
#line 87 "../src/plug/Views/InternetView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 331 "InternetView.c"
			goto __catch0_g_error;
		}
		{
#line 88 "../src/plug/Views/InternetView.vala"
			_data_->url_collection_length1 = 0;
#line 88 "../src/plug/Views/InternetView.vala"
			_data_->_url_collection_size_ = 0;
#line 88 "../src/plug/Views/InternetView.vala"
			_data_->url_collection = _data_->block_urls;
#line 88 "../src/plug/Views/InternetView.vala"
			_data_->url_collection_length1 = _data_->block_urls_length1;
#line 88 "../src/plug/Views/InternetView.vala"
			for (_data_->url_it = 0; _data_->url_it < _data_->url_collection_length1; _data_->url_it = _data_->url_it + 1) {
#line 88 "../src/plug/Views/InternetView.vala"
				_data_->url = _data_->url_collection[_data_->url_it];
#line 347 "InternetView.c"
				{
#line 89 "../src/plug/Views/InternetView.vala"
					_data_->_tmp5_ = _data_->url;
#line 89 "../src/plug/Views/InternetView.vala"
					pc_widgets_internet_box_add_entry (_data_->self, _data_->_tmp5_);
#line 353 "InternetView.c"
				}
			}
		}
#line 86 "../src/plug/Views/InternetView.vala"
		_data_->block_urls = (_vala_array_free (_data_->block_urls, _data_->block_urls_length1, (GDestroyNotify) g_free), NULL);
#line 359 "InternetView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 86 "../src/plug/Views/InternetView.vala"
		_data_->e = _data_->_inner_error0_;
#line 86 "../src/plug/Views/InternetView.vala"
		_data_->_inner_error0_ = NULL;
#line 92 "../src/plug/Views/InternetView.vala"
		_data_->_tmp6_ = _data_->e;
#line 92 "../src/plug/Views/InternetView.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 92 "../src/plug/Views/InternetView.vala"
		g_critical ("InternetView.vala:92: %s", _data_->_tmp7_);
#line 86 "../src/plug/Views/InternetView.vala"
		_g_error_free0 (_data_->e);
#line 376 "InternetView.c"
	}
	__finally0:
#line 86 "../src/plug/Views/InternetView.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 86 "../src/plug/Views/InternetView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 86 "../src/plug/Views/InternetView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 86 "../src/plug/Views/InternetView.vala"
		g_object_unref (_data_->_async_result);
#line 86 "../src/plug/Views/InternetView.vala"
		return FALSE;
#line 389 "InternetView.c"
	}
#line 85 "../src/plug/Views/InternetView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 85 "../src/plug/Views/InternetView.vala"
	if (_data_->_state_ != 0) {
#line 85 "../src/plug/Views/InternetView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 85 "../src/plug/Views/InternetView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 399 "InternetView.c"
		}
	}
#line 85 "../src/plug/Views/InternetView.vala"
	g_object_unref (_data_->_async_result);
#line 85 "../src/plug/Views/InternetView.vala"
	return FALSE;
#line 406 "InternetView.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 106 "../src/plug/Views/InternetView.vala"
	if ((*length) == (*size)) {
#line 106 "../src/plug/Views/InternetView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 106 "../src/plug/Views/InternetView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 421 "InternetView.c"
	}
#line 106 "../src/plug/Views/InternetView.vala"
	(*array)[(*length)++] = value;
#line 106 "../src/plug/Views/InternetView.vala"
	(*array)[*length] = NULL;
#line 427 "InternetView.c"
}

static void
pc_widgets_internet_box_update_block_urls (PCWidgetsInternetBox* self)
{
	PolkitPermission* _tmp0_;
	gchar** block_urls = NULL;
	gchar** _tmp1_;
	gint block_urls_length1;
	gint _block_urls_size_;
	GtkWidget* child = NULL;
	GtkListBox* _tmp2_;
	GtkWidget* _tmp3_;
	PCIParentalControls* _tmp12_;
	ActUser* _tmp13_;
	const gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 96 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/plug/Views/InternetView.vala"
	_tmp0_ = pc_utils_get_permission ();
#line 97 "../src/plug/Views/InternetView.vala"
	if (!g_permission_get_allowed ((GPermission*) _tmp0_)) {
#line 98 "../src/plug/Views/InternetView.vala"
		return;
#line 454 "InternetView.c"
	}
#line 101 "../src/plug/Views/InternetView.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 101 "../src/plug/Views/InternetView.vala"
	block_urls = _tmp1_;
#line 101 "../src/plug/Views/InternetView.vala"
	block_urls_length1 = 0;
#line 101 "../src/plug/Views/InternetView.vala"
	_block_urls_size_ = block_urls_length1;
#line 103 "../src/plug/Views/InternetView.vala"
	_tmp2_ = self->priv->list_box;
#line 103 "../src/plug/Views/InternetView.vala"
	_tmp3_ = gtk_widget_get_first_child ((GtkWidget*) _tmp2_);
#line 103 "../src/plug/Views/InternetView.vala"
	child = _tmp3_;
#line 104 "../src/plug/Views/InternetView.vala"
	while (TRUE) {
#line 472 "InternetView.c"
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
#line 104 "../src/plug/Views/InternetView.vala"
		_tmp4_ = child;
#line 104 "../src/plug/Views/InternetView.vala"
		if (!(_tmp4_ != NULL)) {
#line 104 "../src/plug/Views/InternetView.vala"
			break;
#line 483 "InternetView.c"
		}
#line 105 "../src/plug/Views/InternetView.vala"
		_tmp5_ = child;
#line 105 "../src/plug/Views/InternetView.vala"
		if (PC_WIDGETS_INTERNET_BOX_IS_URL_ENTRY (_tmp5_)) {
#line 489 "InternetView.c"
			GtkWidget* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 106 "../src/plug/Views/InternetView.vala"
			_tmp6_ = child;
#line 106 "../src/plug/Views/InternetView.vala"
			_tmp7_ = pc_widgets_internet_box_url_entry_get_url (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry));
#line 106 "../src/plug/Views/InternetView.vala"
			_tmp8_ = _tmp7_;
#line 106 "../src/plug/Views/InternetView.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 106 "../src/plug/Views/InternetView.vala"
			_vala_array_add4 (&block_urls, &block_urls_length1, &_block_urls_size_, _tmp9_);
#line 504 "InternetView.c"
		}
#line 109 "../src/plug/Views/InternetView.vala"
		_tmp10_ = child;
#line 109 "../src/plug/Views/InternetView.vala"
		_tmp11_ = gtk_widget_get_next_sibling (_tmp10_);
#line 109 "../src/plug/Views/InternetView.vala"
		child = _tmp11_;
#line 512 "InternetView.c"
	}
#line 112 "../src/plug/Views/InternetView.vala"
	_tmp12_ = pc_utils_get_api ();
#line 112 "../src/plug/Views/InternetView.vala"
	_tmp13_ = self->priv->_user;
#line 112 "../src/plug/Views/InternetView.vala"
	_tmp14_ = act_user_get_user_name (_tmp13_);
#line 112 "../src/plug/Views/InternetView.vala"
	_tmp15_ = block_urls;
#line 112 "../src/plug/Views/InternetView.vala"
	_tmp15__length1 = block_urls_length1;
#line 112 "../src/plug/Views/InternetView.vala"
	pc_iparental_controls_set_user_daemon_block_urls (_tmp12_, _tmp14_, _tmp15_, (gint) _tmp15__length1, NULL, NULL);
#line 96 "../src/plug/Views/InternetView.vala"
	block_urls = (_vala_array_free (block_urls, block_urls_length1, (GDestroyNotify) g_free), NULL);
#line 528 "InternetView.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 549 "InternetView.c"
}

static void
pc_widgets_internet_box_on_entry_activate (PCWidgetsInternetBox* self)
{
	GRegex* _tmp0_;
	gchar* url = NULL;
	GraniteValidatedEntry* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GRegex* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GraniteValidatedEntry* _tmp7_;
#line 115 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/plug/Views/InternetView.vala"
	_tmp0_ = self->priv->url_regex;
#line 116 "../src/plug/Views/InternetView.vala"
	if (_tmp0_ == NULL) {
#line 117 "../src/plug/Views/InternetView.vala"
		return;
#line 572 "InternetView.c"
	}
#line 120 "../src/plug/Views/InternetView.vala"
	_tmp1_ = self->priv->entry;
#line 120 "../src/plug/Views/InternetView.vala"
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
#line 120 "../src/plug/Views/InternetView.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 120 "../src/plug/Views/InternetView.vala"
	url = _tmp3_;
#line 121 "../src/plug/Views/InternetView.vala"
	_tmp4_ = self->priv->url_regex;
#line 121 "../src/plug/Views/InternetView.vala"
	_tmp5_ = url;
#line 121 "../src/plug/Views/InternetView.vala"
	if (!g_regex_match (_tmp4_, _tmp5_, 0, NULL)) {
#line 122 "../src/plug/Views/InternetView.vala"
		_g_free0 (url);
#line 122 "../src/plug/Views/InternetView.vala"
		return;
#line 592 "InternetView.c"
	}
#line 125 "../src/plug/Views/InternetView.vala"
	_tmp6_ = url;
#line 125 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_add_entry (self, _tmp6_);
#line 127 "../src/plug/Views/InternetView.vala"
	_tmp7_ = self->priv->entry;
#line 127 "../src/plug/Views/InternetView.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp7_, "");
#line 128 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_update_block_urls (self);
#line 115 "../src/plug/Views/InternetView.vala"
	_g_free0 (url);
#line 606 "InternetView.c"
}

static void
__lambda15_ (PCWidgetsInternetBox* self)
{
#line 133 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_update_block_urls (self);
#line 614 "InternetView.c"
}

static void
___lambda15__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 133 "../src/plug/Views/InternetView.vala"
	__lambda15_ ((PCWidgetsInternetBox*) self);
#line 623 "InternetView.c"
}

static void
pc_widgets_internet_box_add_entry (PCWidgetsInternetBox* self,
                                   const gchar* url)
{
	PCWidgetsInternetBoxUrlEntry* url_entry = NULL;
	PCWidgetsInternetBoxUrlEntry* _tmp0_;
	GtkListBox* _tmp1_;
#line 131 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (url != NULL);
#line 132 "../src/plug/Views/InternetView.vala"
	_tmp0_ = pc_widgets_internet_box_url_entry_new (url);
#line 132 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp0_);
#line 132 "../src/plug/Views/InternetView.vala"
	url_entry = _tmp0_;
#line 133 "../src/plug/Views/InternetView.vala"
	g_signal_connect_object ((GtkWidget*) url_entry, "destroy", (GCallback) ___lambda15__gtk_widget_destroy, self, 0);
#line 134 "../src/plug/Views/InternetView.vala"
	_tmp1_ = self->priv->list_box;
#line 134 "../src/plug/Views/InternetView.vala"
	gtk_list_box_append (_tmp1_, (GtkWidget*) url_entry);
#line 131 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (url_entry);
#line 651 "InternetView.c"
}

ActUser*
pc_widgets_internet_box_get_user (PCWidgetsInternetBox* self)
{
	ActUser* result;
	ActUser* _tmp0_;
#line 10 "../src/plug/Views/InternetView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/plug/Views/InternetView.vala"
	_tmp0_ = self->priv->_user;
#line 10 "../src/plug/Views/InternetView.vala"
	result = _tmp0_;
#line 10 "../src/plug/Views/InternetView.vala"
	return result;
#line 667 "InternetView.c"
}

static void
pc_widgets_internet_box_set_user (PCWidgetsInternetBox* self,
                                  ActUser* value)
{
	ActUser* old_value;
#line 10 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/plug/Views/InternetView.vala"
	old_value = pc_widgets_internet_box_get_user (self);
#line 10 "../src/plug/Views/InternetView.vala"
	if (old_value != value) {
#line 10 "../src/plug/Views/InternetView.vala"
		self->priv->_user = value;
#line 10 "../src/plug/Views/InternetView.vala"
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_USER_PROPERTY]);
#line 685 "InternetView.c"
	}
}

static inline gpointer
pc_widgets_internet_box_url_entry_get_instance_private (PCWidgetsInternetBoxUrlEntry* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsInternetBoxUrlEntry_private_offset);
}

static PCWidgetsInternetBoxUrlEntry*
pc_widgets_internet_box_url_entry_construct (GType object_type,
                                             const gchar* url)
{
	PCWidgetsInternetBoxUrlEntry * self = NULL;
#line 140 "../src/plug/Views/InternetView.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 141 "../src/plug/Views/InternetView.vala"
	self = (PCWidgetsInternetBoxUrlEntry*) g_object_new (object_type, "url", url, NULL);
#line 140 "../src/plug/Views/InternetView.vala"
	return self;
#line 706 "InternetView.c"
}

static PCWidgetsInternetBoxUrlEntry*
pc_widgets_internet_box_url_entry_new (const gchar* url)
{
#line 140 "../src/plug/Views/InternetView.vala"
	return pc_widgets_internet_box_url_entry_construct (PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, url);
#line 714 "InternetView.c"
}

static const gchar*
pc_widgets_internet_box_url_entry_get_url (PCWidgetsInternetBoxUrlEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 138 "../src/plug/Views/InternetView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/plug/Views/InternetView.vala"
	_tmp0_ = self->priv->_url;
#line 138 "../src/plug/Views/InternetView.vala"
	result = _tmp0_;
#line 138 "../src/plug/Views/InternetView.vala"
	return result;
#line 730 "InternetView.c"
}

static void
pc_widgets_internet_box_url_entry_set_url (PCWidgetsInternetBoxUrlEntry* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 138 "../src/plug/Views/InternetView.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/plug/Views/InternetView.vala"
	old_value = pc_widgets_internet_box_url_entry_get_url (self);
#line 138 "../src/plug/Views/InternetView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 744 "InternetView.c"
		gchar* _tmp0_;
#line 138 "../src/plug/Views/InternetView.vala"
		_tmp0_ = g_strdup (value);
#line 138 "../src/plug/Views/InternetView.vala"
		_g_free0 (self->priv->_url);
#line 138 "../src/plug/Views/InternetView.vala"
		self->priv->_url = _tmp0_;
#line 138 "../src/plug/Views/InternetView.vala"
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY]);
#line 754 "InternetView.c"
	}
}

static void
_pc_widgets_internet_box_url_entry___lambda14_ (PCWidgetsInternetBoxUrlEntry* self)
{
#line 152 "../src/plug/Views/InternetView.vala"
	gtk_widget_unparent ((GtkWidget*) self);
#line 153 "../src/plug/Views/InternetView.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "destroy");
#line 765 "InternetView.c"
}

static void
__pc_widgets_internet_box_url_entry___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
#line 151 "../src/plug/Views/InternetView.vala"
	_pc_widgets_internet_box_url_entry___lambda14_ ((PCWidgetsInternetBoxUrlEntry*) self);
#line 774 "InternetView.c"
}

static GObject *
pc_widgets_internet_box_url_entry_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsInternetBoxUrlEntry * self;
	GtkButton* delete_button = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkButton* _tmp2_ = NULL;
	GtkButton* _tmp3_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp4_ = NULL;
	GtkBox* _tmp5_;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBox* _tmp9_;
	GtkButton* _tmp10_;
	GtkBox* _tmp11_;
#line 144 "../src/plug/Views/InternetView.vala"
	parent_class = G_OBJECT_CLASS (pc_widgets_internet_box_url_entry_parent_class);
#line 144 "../src/plug/Views/InternetView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 144 "../src/plug/Views/InternetView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
#line 145 "../src/plug/Views/InternetView.vala"
	_tmp0_ = self->priv->_url;
#line 145 "../src/plug/Views/InternetView.vala"
	_tmp1_ = g_strdup_printf (_ ("Unblock %s"), _tmp0_);
#line 145 "../src/plug/Views/InternetView.vala"
	_tmp2_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic");
#line 145 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 145 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 145 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _tmp1_);
#line 145 "../src/plug/Views/InternetView.vala"
	_g_free0 (_tmp1_);
#line 145 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp2_);
#line 145 "../src/plug/Views/InternetView.vala"
	delete_button = _tmp2_;
#line 151 "../src/plug/Views/InternetView.vala"
	_tmp3_ = delete_button;
#line 151 "../src/plug/Views/InternetView.vala"
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) __pc_widgets_internet_box_url_entry___lambda14__gtk_button_clicked, self, 0);
#line 156 "../src/plug/Views/InternetView.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 156 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 6);
#line 156 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, 6);
#line 156 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 6);
#line 156 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 6);
#line 156 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp4_);
#line 156 "../src/plug/Views/InternetView.vala"
	main_box = _tmp4_;
#line 162 "../src/plug/Views/InternetView.vala"
	_tmp5_ = main_box;
#line 162 "../src/plug/Views/InternetView.vala"
	_tmp6_ = self->priv->_url;
#line 162 "../src/plug/Views/InternetView.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
#line 162 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp7_);
#line 162 "../src/plug/Views/InternetView.vala"
	_tmp8_ = _tmp7_;
#line 162 "../src/plug/Views/InternetView.vala"
	gtk_box_append (_tmp5_, (GtkWidget*) _tmp8_);
#line 162 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (_tmp8_);
#line 163 "../src/plug/Views/InternetView.vala"
	_tmp9_ = main_box;
#line 163 "../src/plug/Views/InternetView.vala"
	_tmp10_ = delete_button;
#line 163 "../src/plug/Views/InternetView.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 165 "../src/plug/Views/InternetView.vala"
	_tmp11_ = main_box;
#line 165 "../src/plug/Views/InternetView.vala"
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp11_);
#line 144 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (main_box);
#line 144 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (delete_button);
#line 144 "../src/plug/Views/InternetView.vala"
	return obj;
#line 871 "InternetView.c"
}

static void
pc_widgets_internet_box_url_entry_class_init (PCWidgetsInternetBoxUrlEntryClass * klass,
                                              gpointer klass_data)
{
#line 137 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_url_entry_parent_class = g_type_class_peek_parent (klass);
#line 137 "../src/plug/Views/InternetView.vala"
	g_type_class_adjust_private_offset (klass, &PCWidgetsInternetBoxUrlEntry_private_offset);
#line 137 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_internet_box_url_entry_get_property;
#line 137 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_internet_box_url_entry_set_property;
#line 137 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_internet_box_url_entry_constructor;
#line 137 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_internet_box_url_entry_finalize;
#line 137 "../src/plug/Views/InternetView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY, pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 892 "InternetView.c"
}

static void
pc_widgets_internet_box_url_entry_instance_init (PCWidgetsInternetBoxUrlEntry * self,
                                                 gpointer klass)
{
#line 137 "../src/plug/Views/InternetView.vala"
	self->priv = pc_widgets_internet_box_url_entry_get_instance_private (self);
#line 901 "InternetView.c"
}

static void
pc_widgets_internet_box_url_entry_finalize (GObject * obj)
{
	PCWidgetsInternetBoxUrlEntry * self;
#line 137 "../src/plug/Views/InternetView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
#line 138 "../src/plug/Views/InternetView.vala"
	_g_free0 (self->priv->_url);
#line 137 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (pc_widgets_internet_box_url_entry_parent_class)->finalize (obj);
#line 914 "InternetView.c"
}

static GType
pc_widgets_internet_box_url_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsInternetBoxUrlEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_internet_box_url_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsInternetBoxUrlEntry), 0, (GInstanceInitFunc) pc_widgets_internet_box_url_entry_instance_init, NULL };
	GType pc_widgets_internet_box_url_entry_type_id;
	pc_widgets_internet_box_url_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "PCWidgetsInternetBoxUrlEntry", &g_define_type_info, 0);
	PCWidgetsInternetBoxUrlEntry_private_offset = g_type_add_instance_private (pc_widgets_internet_box_url_entry_type_id, sizeof (PCWidgetsInternetBoxUrlEntryPrivate));
	return pc_widgets_internet_box_url_entry_type_id;
}

static GType
pc_widgets_internet_box_url_entry_get_type (void)
{
	static volatile gsize pc_widgets_internet_box_url_entry_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_internet_box_url_entry_type_id__once)) {
		GType pc_widgets_internet_box_url_entry_type_id;
		pc_widgets_internet_box_url_entry_type_id = pc_widgets_internet_box_url_entry_get_type_once ();
		g_once_init_leave (&pc_widgets_internet_box_url_entry_type_id__once, pc_widgets_internet_box_url_entry_type_id);
	}
	return pc_widgets_internet_box_url_entry_type_id__once;
}

static void
_vala_pc_widgets_internet_box_url_entry_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	PCWidgetsInternetBoxUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
#line 137 "../src/plug/Views/InternetView.vala"
	switch (property_id) {
#line 137 "../src/plug/Views/InternetView.vala"
		case PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY:
#line 137 "../src/plug/Views/InternetView.vala"
		g_value_set_string (value, pc_widgets_internet_box_url_entry_get_url (self));
#line 137 "../src/plug/Views/InternetView.vala"
		break;
#line 955 "InternetView.c"
		default:
#line 137 "../src/plug/Views/InternetView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 137 "../src/plug/Views/InternetView.vala"
		break;
#line 961 "InternetView.c"
	}
}

static void
_vala_pc_widgets_internet_box_url_entry_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	PCWidgetsInternetBoxUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
#line 137 "../src/plug/Views/InternetView.vala"
	switch (property_id) {
#line 137 "../src/plug/Views/InternetView.vala"
		case PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY:
#line 137 "../src/plug/Views/InternetView.vala"
		pc_widgets_internet_box_url_entry_set_url (self, g_value_get_string (value));
#line 137 "../src/plug/Views/InternetView.vala"
		break;
#line 981 "InternetView.c"
		default:
#line 137 "../src/plug/Views/InternetView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 137 "../src/plug/Views/InternetView.vala"
		break;
#line 987 "InternetView.c"
	}
}

static void
_pc_widgets_internet_box_on_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 44 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_on_entry_activate ((PCWidgetsInternetBox*) self);
#line 997 "InternetView.c"
}

static void
_pc_widgets_internet_box___lambda16_ (PCWidgetsInternetBox* self)
{
	GraniteValidatedEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 75 "../src/plug/Views/InternetView.vala"
	_tmp0_ = self->priv->entry;
#line 75 "../src/plug/Views/InternetView.vala"
	_tmp1_ = granite_validated_entry_get_is_valid (_tmp0_);
#line 75 "../src/plug/Views/InternetView.vala"
	_tmp2_ = _tmp1_;
#line 75 "../src/plug/Views/InternetView.vala"
	if (_tmp2_) {
#line 1014 "InternetView.c"
		GraniteValidatedEntry* _tmp3_;
#line 76 "../src/plug/Views/InternetView.vala"
		_tmp3_ = self->priv->entry;
#line 76 "../src/plug/Views/InternetView.vala"
		g_object_set ((GtkEntry*) _tmp3_, "secondary-icon-tooltip-text", NULL, NULL);
#line 1020 "InternetView.c"
	} else {
		GraniteValidatedEntry* _tmp4_;
#line 78 "../src/plug/Views/InternetView.vala"
		_tmp4_ = self->priv->entry;
#line 78 "../src/plug/Views/InternetView.vala"
		g_object_set ((GtkEntry*) _tmp4_, "secondary-icon-tooltip-text", _ ("Invalid URL"), NULL);
#line 1027 "InternetView.c"
	}
}

static void
__pc_widgets_internet_box___lambda16__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 74 "../src/plug/Views/InternetView.vala"
	_pc_widgets_internet_box___lambda16_ ((PCWidgetsInternetBox*) self);
#line 1038 "InternetView.c"
}

static void
_pc_widgets_internet_box_on_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                               gpointer self)
{
#line 82 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_on_entry_activate ((PCWidgetsInternetBox*) self);
#line 1047 "InternetView.c"
}

static GObject *
pc_widgets_internet_box_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsInternetBox * self;
	GraniteHeaderLabel* info_label = NULL;
	GraniteHeaderLabel* _tmp5_;
	GtkListBox* _tmp6_ = NULL;
	GtkScrolledWindow* scrolled = NULL;
	GtkListBox* _tmp7_;
	GtkWidget* _tmp8_;
	GtkScrolledWindow* _tmp9_ = NULL;
	GtkButton* _tmp10_ = NULL;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GRegex* _tmp13_;
	gchar* _tmp14_;
	GraniteValidatedEntry* _tmp15_ = NULL;
	GtkGrid* main_box = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_;
	GtkScrolledWindow* _tmp18_;
	GtkGrid* _tmp19_;
	GtkSeparator* _tmp20_;
	GtkSeparator* _tmp21_;
	GtkGrid* _tmp22_;
	GraniteValidatedEntry* _tmp23_;
	GtkGrid* _tmp24_;
	GtkButton* _tmp25_;
	GtkFrame* frame = NULL;
	GtkGrid* _tmp26_;
	GtkWidget* _tmp27_;
	GtkFrame* _tmp28_ = NULL;
	GtkFrame* _tmp29_;
	GraniteHeaderLabel* _tmp30_;
	GtkFrame* _tmp31_;
	GraniteValidatedEntry* _tmp32_;
	GtkButton* _tmp33_;
	GraniteValidatedEntry* _tmp34_;
	GraniteValidatedEntry* _tmp35_;
	GError* _inner_error0_ = NULL;
#line 21 "../src/plug/Views/InternetView.vala"
	parent_class = G_OBJECT_CLASS (pc_widgets_internet_box_parent_class);
#line 21 "../src/plug/Views/InternetView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 21 "../src/plug/Views/InternetView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
#line 1100 "InternetView.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 23 "../src/plug/Views/InternetView.vala"
		_tmp1_ = g_regex_new (PC_WIDGETS_INTERNET_BOX_URL_REGEX, G_REGEX_OPTIMIZE, 0, &_inner_error0_);
#line 23 "../src/plug/Views/InternetView.vala"
		_tmp0_ = _tmp1_;
#line 23 "../src/plug/Views/InternetView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23 "../src/plug/Views/InternetView.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1113 "InternetView.c"
				goto __catch0_g_regex_error;
			}
#line 23 "../src/plug/Views/InternetView.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 23 "../src/plug/Views/InternetView.vala"
			g_clear_error (&_inner_error0_);
#line 1120 "InternetView.c"
		}
#line 23 "../src/plug/Views/InternetView.vala"
		_tmp2_ = _tmp0_;
#line 23 "../src/plug/Views/InternetView.vala"
		_tmp0_ = NULL;
#line 23 "../src/plug/Views/InternetView.vala"
		_g_regex_unref0 (self->priv->url_regex);
#line 23 "../src/plug/Views/InternetView.vala"
		self->priv->url_regex = _tmp2_;
#line 22 "../src/plug/Views/InternetView.vala"
		_g_regex_unref0 (_tmp0_);
#line 1132 "InternetView.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 22 "../src/plug/Views/InternetView.vala"
		e = _inner_error0_;
#line 22 "../src/plug/Views/InternetView.vala"
		_inner_error0_ = NULL;
#line 25 "../src/plug/Views/InternetView.vala"
		_tmp3_ = e;
#line 25 "../src/plug/Views/InternetView.vala"
		_tmp4_ = _tmp3_->message;
#line 25 "../src/plug/Views/InternetView.vala"
		g_warning ("InternetView.vala:25: %s\n", _tmp4_);
#line 22 "../src/plug/Views/InternetView.vala"
		_g_error_free0 (e);
#line 1152 "InternetView.c"
	}
	__finally0:
#line 22 "../src/plug/Views/InternetView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22 "../src/plug/Views/InternetView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 22 "../src/plug/Views/InternetView.vala"
		g_clear_error (&_inner_error0_);
#line 1161 "InternetView.c"
	}
#line 28 "../src/plug/Views/InternetView.vala"
	_tmp5_ = granite_header_label_new (_ ("Blocked Websites"));
#line 28 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp5_);
#line 28 "../src/plug/Views/InternetView.vala"
	info_label = _tmp5_;
#line 30 "../src/plug/Views/InternetView.vala"
	_tmp6_ = (GtkListBox*) gtk_list_box_new ();
#line 30 "../src/plug/Views/InternetView.vala"
	gtk_list_box_set_selection_mode (_tmp6_, GTK_SELECTION_NONE);
#line 30 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp6_);
#line 30 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 30 "../src/plug/Views/InternetView.vala"
	self->priv->list_box = _tmp6_;
#line 34 "../src/plug/Views/InternetView.vala"
	_tmp7_ = self->priv->list_box;
#line 34 "../src/plug/Views/InternetView.vala"
	_tmp8_ = _g_object_ref0 ((GtkWidget*) _tmp7_);
#line 34 "../src/plug/Views/InternetView.vala"
	_tmp9_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 34 "../src/plug/Views/InternetView.vala"
	gtk_scrolled_window_set_child (_tmp9_, _tmp8_);
#line 34 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (_tmp8_);
#line 34 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp9_, TRUE);
#line 34 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp9_);
#line 34 "../src/plug/Views/InternetView.vala"
	scrolled = _tmp9_;
#line 39 "../src/plug/Views/InternetView.vala"
	_tmp10_ = (GtkButton*) gtk_button_new_with_label (_ ("Block URL"));
#line 39 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp10_, 6);
#line 39 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 39 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp10_);
#line 39 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->add_button);
#line 39 "../src/plug/Views/InternetView.vala"
	self->priv->add_button = _tmp10_;
#line 43 "../src/plug/Views/InternetView.vala"
	_tmp11_ = self->priv->add_button;
#line 43 "../src/plug/Views/InternetView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp11_, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 44 "../src/plug/Views/InternetView.vala"
	_tmp12_ = self->priv->add_button;
#line 44 "../src/plug/Views/InternetView.vala"
	g_signal_connect_object (_tmp12_, "clicked", (GCallback) _pc_widgets_internet_box_on_entry_activate_gtk_button_clicked, self, 0);
#line 46 "../src/plug/Views/InternetView.vala"
	_tmp13_ = self->priv->url_regex;
#line 46 "../src/plug/Views/InternetView.vala"
	_tmp14_ = g_strdup (_ ("example.com"));
#line 46 "../src/plug/Views/InternetView.vala"
	_tmp15_ = granite_validated_entry_new_from_regex (_tmp13_);
#line 46 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
#line 46 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp15_, 6);
#line 46 "../src/plug/Views/InternetView.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp15_, _tmp14_);
#line 46 "../src/plug/Views/InternetView.vala"
	_g_free0 (_tmp14_);
#line 46 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp15_);
#line 46 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->entry);
#line 46 "../src/plug/Views/InternetView.vala"
	self->priv->entry = _tmp15_;
#line 52 "../src/plug/Views/InternetView.vala"
	_tmp16_ = (GtkGrid*) gtk_grid_new ();
#line 52 "../src/plug/Views/InternetView.vala"
	gtk_grid_set_column_spacing (_tmp16_, 6);
#line 52 "../src/plug/Views/InternetView.vala"
	gtk_grid_set_row_spacing (_tmp16_, 6);
#line 52 "../src/plug/Views/InternetView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp16_, 6);
#line 52 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp16_);
#line 52 "../src/plug/Views/InternetView.vala"
	main_box = _tmp16_;
#line 57 "../src/plug/Views/InternetView.vala"
	_tmp17_ = main_box;
#line 57 "../src/plug/Views/InternetView.vala"
	_tmp18_ = scrolled;
#line 57 "../src/plug/Views/InternetView.vala"
	gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, 0, 2, 1);
#line 58 "../src/plug/Views/InternetView.vala"
	_tmp19_ = main_box;
#line 58 "../src/plug/Views/InternetView.vala"
	_tmp20_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 58 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp20_);
#line 58 "../src/plug/Views/InternetView.vala"
	_tmp21_ = _tmp20_;
#line 58 "../src/plug/Views/InternetView.vala"
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp21_, 0, 1, 2, 1);
#line 58 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (_tmp21_);
#line 59 "../src/plug/Views/InternetView.vala"
	_tmp22_ = main_box;
#line 59 "../src/plug/Views/InternetView.vala"
	_tmp23_ = self->priv->entry;
#line 59 "../src/plug/Views/InternetView.vala"
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 0, 3, 1, 1);
#line 60 "../src/plug/Views/InternetView.vala"
	_tmp24_ = main_box;
#line 60 "../src/plug/Views/InternetView.vala"
	_tmp25_ = self->priv->add_button;
#line 60 "../src/plug/Views/InternetView.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 1, 3, 1, 1);
#line 62 "../src/plug/Views/InternetView.vala"
	_tmp26_ = main_box;
#line 62 "../src/plug/Views/InternetView.vala"
	_tmp27_ = _g_object_ref0 ((GtkWidget*) _tmp26_);
#line 62 "../src/plug/Views/InternetView.vala"
	_tmp28_ = (GtkFrame*) gtk_frame_new (NULL);
#line 62 "../src/plug/Views/InternetView.vala"
	gtk_frame_set_child (_tmp28_, _tmp27_);
#line 62 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (_tmp27_);
#line 62 "../src/plug/Views/InternetView.vala"
	g_object_ref_sink (_tmp28_);
#line 62 "../src/plug/Views/InternetView.vala"
	frame = _tmp28_;
#line 65 "../src/plug/Views/InternetView.vala"
	_tmp29_ = frame;
#line 65 "../src/plug/Views/InternetView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp29_, GRANITE_STYLE_CLASS_VIEW);
#line 67 "../src/plug/Views/InternetView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 68 "../src/plug/Views/InternetView.vala"
	gtk_box_set_spacing ((GtkBox*) self, 6);
#line 69 "../src/plug/Views/InternetView.vala"
	_tmp30_ = info_label;
#line 69 "../src/plug/Views/InternetView.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp30_);
#line 70 "../src/plug/Views/InternetView.vala"
	_tmp31_ = frame;
#line 70 "../src/plug/Views/InternetView.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp31_);
#line 71 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_load_existing (self, NULL, NULL);
#line 73 "../src/plug/Views/InternetView.vala"
	_tmp32_ = self->priv->entry;
#line 73 "../src/plug/Views/InternetView.vala"
	_tmp33_ = self->priv->add_button;
#line 73 "../src/plug/Views/InternetView.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp32_, "is-valid", (GObject*) _tmp33_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 74 "../src/plug/Views/InternetView.vala"
	_tmp34_ = self->priv->entry;
#line 74 "../src/plug/Views/InternetView.vala"
	g_signal_connect_object ((GObject*) _tmp34_, "notify::is-valid", (GCallback) __pc_widgets_internet_box___lambda16__g_object_notify, self, 0);
#line 82 "../src/plug/Views/InternetView.vala"
	_tmp35_ = self->priv->entry;
#line 82 "../src/plug/Views/InternetView.vala"
	g_signal_connect_object ((GtkEntry*) _tmp35_, "activate", (GCallback) _pc_widgets_internet_box_on_entry_activate_gtk_entry_activate, self, 0);
#line 21 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (frame);
#line 21 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (main_box);
#line 21 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (scrolled);
#line 21 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (info_label);
#line 21 "../src/plug/Views/InternetView.vala"
	return obj;
#line 1333 "InternetView.c"
}

static void
pc_widgets_internet_box_class_init (PCWidgetsInternetBoxClass * klass,
                                    gpointer klass_data)
{
#line 7 "../src/plug/Views/InternetView.vala"
	pc_widgets_internet_box_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/plug/Views/InternetView.vala"
	g_type_class_adjust_private_offset (klass, &PCWidgetsInternetBox_private_offset);
#line 7 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_internet_box_get_property;
#line 7 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_internet_box_set_property;
#line 7 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_internet_box_constructor;
#line 7 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_internet_box_finalize;
#line 7 "../src/plug/Views/InternetView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_INTERNET_BOX_USER_PROPERTY, pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", act_user_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1354 "InternetView.c"
}

static void
pc_widgets_internet_box_instance_init (PCWidgetsInternetBox * self,
                                       gpointer klass)
{
#line 7 "../src/plug/Views/InternetView.vala"
	self->priv = pc_widgets_internet_box_get_instance_private (self);
#line 11 "../src/plug/Views/InternetView.vala"
	self->priv->url_regex = NULL;
#line 1365 "InternetView.c"
}

static void
pc_widgets_internet_box_finalize (GObject * obj)
{
	PCWidgetsInternetBox * self;
#line 7 "../src/plug/Views/InternetView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
#line 11 "../src/plug/Views/InternetView.vala"
	_g_regex_unref0 (self->priv->url_regex);
#line 13 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 14 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->entry);
#line 15 "../src/plug/Views/InternetView.vala"
	_g_object_unref0 (self->priv->add_button);
#line 7 "../src/plug/Views/InternetView.vala"
	G_OBJECT_CLASS (pc_widgets_internet_box_parent_class)->finalize (obj);
#line 1384 "InternetView.c"
}

static GType
pc_widgets_internet_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsInternetBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_internet_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsInternetBox), 0, (GInstanceInitFunc) pc_widgets_internet_box_instance_init, NULL };
	GType pc_widgets_internet_box_type_id;
	pc_widgets_internet_box_type_id = g_type_register_static (gtk_box_get_type (), "PCWidgetsInternetBox", &g_define_type_info, 0);
	PCWidgetsInternetBox_private_offset = g_type_add_instance_private (pc_widgets_internet_box_type_id, sizeof (PCWidgetsInternetBoxPrivate));
	return pc_widgets_internet_box_type_id;
}

GType
pc_widgets_internet_box_get_type (void)
{
	static volatile gsize pc_widgets_internet_box_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_internet_box_type_id__once)) {
		GType pc_widgets_internet_box_type_id;
		pc_widgets_internet_box_type_id = pc_widgets_internet_box_get_type_once ();
		g_once_init_leave (&pc_widgets_internet_box_type_id__once, pc_widgets_internet_box_type_id);
	}
	return pc_widgets_internet_box_type_id__once;
}

static void
_vala_pc_widgets_internet_box_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsInternetBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
#line 7 "../src/plug/Views/InternetView.vala"
	switch (property_id) {
#line 7 "../src/plug/Views/InternetView.vala"
		case PC_WIDGETS_INTERNET_BOX_USER_PROPERTY:
#line 7 "../src/plug/Views/InternetView.vala"
		g_value_set_object (value, pc_widgets_internet_box_get_user (self));
#line 7 "../src/plug/Views/InternetView.vala"
		break;
#line 1425 "InternetView.c"
		default:
#line 7 "../src/plug/Views/InternetView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/plug/Views/InternetView.vala"
		break;
#line 1431 "InternetView.c"
	}
}

static void
_vala_pc_widgets_internet_box_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsInternetBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
#line 7 "../src/plug/Views/InternetView.vala"
	switch (property_id) {
#line 7 "../src/plug/Views/InternetView.vala"
		case PC_WIDGETS_INTERNET_BOX_USER_PROPERTY:
#line 7 "../src/plug/Views/InternetView.vala"
		pc_widgets_internet_box_set_user (self, g_value_get_object (value));
#line 7 "../src/plug/Views/InternetView.vala"
		break;
#line 1451 "InternetView.c"
		default:
#line 7 "../src/plug/Views/InternetView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/plug/Views/InternetView.vala"
		break;
#line 1457 "InternetView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

