/* Writer.c generated by valac 0.56.17, the Vala compiler
 * generated from Writer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "screentime-limits.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PC_PAM_WRITER_0_PROPERTY,
	PC_PAM_WRITER_NUM_PROPERTIES
};
static GParamSpec* pc_pam_writer_properties[PC_PAM_WRITER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _PCPAMWriterPrivate {
	gchar* filename;
};

static gint PCPAMWriter_private_offset;
static gpointer pc_pam_writer_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void pc_pam_writer_finalize (GObject * obj);
static GType pc_pam_writer_get_type_once (void);

static inline gpointer
pc_pam_writer_get_instance_private (PCPAMWriter* self)
{
	return G_STRUCT_MEMBER_P (self, PCPAMWriter_private_offset);
}

PCPAMWriter*
pc_pam_writer_new_for_time (void)
{
	PCPAMWriter* _tmp0_;
	PCPAMWriter* result;
#line 28 "../src/common/PAM/Writer.vala"
	_tmp0_ = pc_pam_writer_new (PC_CONSTANTS_PAM_TIME_CONF_PATH);
#line 28 "../src/common/PAM/Writer.vala"
	result = _tmp0_;
#line 28 "../src/common/PAM/Writer.vala"
	return result;
#line 82 "Writer.c"
}

PCPAMWriter*
pc_pam_writer_construct (GType object_type,
                         const gchar* filename)
{
	PCPAMWriter * self = NULL;
	gchar* _tmp0_;
#line 31 "../src/common/PAM/Writer.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 31 "../src/common/PAM/Writer.vala"
	self = (PCPAMWriter*) g_object_new (object_type, NULL);
#line 32 "../src/common/PAM/Writer.vala"
	_tmp0_ = g_strdup (filename);
#line 32 "../src/common/PAM/Writer.vala"
	_g_free0 (self->priv->filename);
#line 32 "../src/common/PAM/Writer.vala"
	self->priv->filename = _tmp0_;
#line 31 "../src/common/PAM/Writer.vala"
	return self;
#line 103 "Writer.c"
}

PCPAMWriter*
pc_pam_writer_new (const gchar* filename)
{
#line 31 "../src/common/PAM/Writer.vala"
	return pc_pam_writer_construct (PC_PAM_TYPE_WRITER, filename);
#line 111 "Writer.c"
}

static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	void* _tmp6_;
	gchar* dest = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* result;
#line 1548 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1549 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1549 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1549 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1550 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1551 "glib-2.0.vapi"
		start = string_length + start;
#line 147 "Writer.c"
	}
#line 1553 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1554 "glib-2.0.vapi"
		end = string_length + end;
#line 153 "Writer.c"
	}
#line 1556 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 159 "Writer.c"
	} else {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 163 "Writer.c"
	}
#line 1556 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1557 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 171 "Writer.c"
	} else {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 175 "Writer.c"
	}
#line 1557 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1558 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1561 "glib-2.0.vapi"
	if (str == NULL) {
#line 1562 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 185 "Writer.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 1564 "glib-2.0.vapi"
		_tmp4_ = strlen ((const gchar*) str);
#line 1564 "glib-2.0.vapi"
		_tmp5_ = _tmp4_;
#line 1564 "glib-2.0.vapi"
		str_size = (gsize) _tmp5_;
#line 195 "Writer.c"
	}
#line 1567 "glib-2.0.vapi"
	_tmp6_ = g_malloc0 (((string_length - (end - start)) + str_size) + 1);
#line 1567 "glib-2.0.vapi"
	_result_ = _tmp6_;
#line 1569 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1569 "glib-2.0.vapi"
	dest = (gchar*) _tmp7_;
#line 1571 "glib-2.0.vapi"
	_tmp8_ = dest;
#line 1571 "glib-2.0.vapi"
	memcpy (_tmp8_, self, (gsize) start);
#line 1572 "glib-2.0.vapi"
	_tmp9_ = dest;
#line 1572 "glib-2.0.vapi"
	dest = _tmp9_ + start;
#line 1574 "glib-2.0.vapi"
	if (str != NULL) {
#line 215 "Writer.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1575 "glib-2.0.vapi"
		_tmp10_ = dest;
#line 1575 "glib-2.0.vapi"
		memcpy (_tmp10_, str, str_size);
#line 1576 "glib-2.0.vapi"
		_tmp11_ = dest;
#line 1576 "glib-2.0.vapi"
		dest = _tmp11_ + str_size;
#line 226 "Writer.c"
	}
#line 1579 "glib-2.0.vapi"
	_tmp12_ = dest;
#line 1579 "glib-2.0.vapi"
	memcpy (_tmp12_, ((gchar*) self) + end, (gsize) (string_length - end));
#line 1581 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1581 "glib-2.0.vapi"
	_result_ = NULL;
#line 1581 "glib-2.0.vapi"
	result = (gchar*) _tmp13_;
#line 1581 "glib-2.0.vapi"
	return result;
#line 240 "Writer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/common/PAM/Writer.vala"
	return self ? g_object_ref (self) : NULL;
#line 248 "Writer.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 63 "../src/common/PAM/Writer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 256 "Writer.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 63 "../src/common/PAM/Writer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 264 "Writer.c"
}

void
pc_pam_writer_add_restriction_for_user (PCPAMWriter* self,
                                        const gchar* input,
                                        gboolean clean)
{
	gchar* clean_username = NULL;
	gchar* contents = NULL;
	gint start_idx = 0;
	gint end_idx = 0;
	gchar* config = NULL;
	const gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GString* builder = NULL;
	GString* _tmp15_;
	GString* _tmp16_;
	const gchar* _tmp17_;
	GList* _tmp18_;
	GString* _tmp30_;
	GString* _tmp31_;
	GString* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 35 "../src/common/PAM/Writer.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/common/PAM/Writer.vala"
	g_return_if_fail (input != NULL);
#line 36 "../src/common/PAM/Writer.vala"
	clean_username = NULL;
#line 37 "../src/common/PAM/Writer.vala"
	if (clean) {
#line 299 "Writer.c"
		PCPAMToken* token = NULL;
		PCPAMToken* _tmp0_;
		PCPAMToken* _tmp1_;
#line 38 "../src/common/PAM/Writer.vala"
		_tmp0_ = pc_pam_token_parse_line (input);
#line 38 "../src/common/PAM/Writer.vala"
		token = _tmp0_;
#line 39 "../src/common/PAM/Writer.vala"
		_tmp1_ = token;
#line 39 "../src/common/PAM/Writer.vala"
		if (_tmp1_ != NULL) {
#line 311 "Writer.c"
			PCPAMToken* _tmp2_;
			gchar* _tmp3_;
#line 40 "../src/common/PAM/Writer.vala"
			_tmp2_ = token;
#line 40 "../src/common/PAM/Writer.vala"
			_tmp3_ = pc_pam_token_get_user_arg0 (_tmp2_);
#line 40 "../src/common/PAM/Writer.vala"
			_g_free0 (clean_username);
#line 40 "../src/common/PAM/Writer.vala"
			clean_username = _tmp3_;
#line 322 "Writer.c"
		}
#line 37 "../src/common/PAM/Writer.vala"
		_g_object_unref0 (token);
#line 326 "Writer.c"
	}
	{
		const gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
#line 46 "../src/common/PAM/Writer.vala"
		_tmp4_ = self->priv->filename;
#line 46 "../src/common/PAM/Writer.vala"
		g_file_get_contents (_tmp4_, &_tmp5_, NULL, &_inner_error0_);
#line 46 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 46 "../src/common/PAM/Writer.vala"
		contents = _tmp5_;
#line 46 "../src/common/PAM/Writer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/common/PAM/Writer.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 343 "Writer.c"
				goto __catch0_g_file_error;
			}
#line 46 "../src/common/PAM/Writer.vala"
			_g_free0 (contents);
#line 46 "../src/common/PAM/Writer.vala"
			_g_free0 (clean_username);
#line 46 "../src/common/PAM/Writer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/common/PAM/Writer.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/common/PAM/Writer.vala"
			return;
#line 356 "Writer.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 45 "../src/common/PAM/Writer.vala"
		e = _inner_error0_;
#line 45 "../src/common/PAM/Writer.vala"
		_inner_error0_ = NULL;
#line 48 "../src/common/PAM/Writer.vala"
		_tmp6_ = e;
#line 48 "../src/common/PAM/Writer.vala"
		_tmp7_ = _tmp6_->message;
#line 48 "../src/common/PAM/Writer.vala"
		g_warning ("Writer.vala:48: %s", _tmp7_);
#line 49 "../src/common/PAM/Writer.vala"
		_g_error_free0 (e);
#line 49 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 49 "../src/common/PAM/Writer.vala"
		_g_free0 (clean_username);
#line 49 "../src/common/PAM/Writer.vala"
		return;
#line 383 "Writer.c"
	}
	__finally0:
#line 45 "../src/common/PAM/Writer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 45 "../src/common/PAM/Writer.vala"
		_g_free0 (clean_username);
#line 45 "../src/common/PAM/Writer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "../src/common/PAM/Writer.vala"
		g_clear_error (&_inner_error0_);
#line 45 "../src/common/PAM/Writer.vala"
		return;
#line 398 "Writer.c"
	}
#line 54 "../src/common/PAM/Writer.vala"
	_tmp8_ = contents;
#line 54 "../src/common/PAM/Writer.vala"
	_tmp11_ = pc_pam_reader_get_config (_tmp8_, &_tmp9_, &_tmp10_);
#line 54 "../src/common/PAM/Writer.vala"
	start_idx = _tmp9_;
#line 54 "../src/common/PAM/Writer.vala"
	end_idx = _tmp10_;
#line 54 "../src/common/PAM/Writer.vala"
	config = _tmp11_;
#line 56 "../src/common/PAM/Writer.vala"
	if (start_idx != -1) {
#line 56 "../src/common/PAM/Writer.vala"
		_tmp12_ = end_idx != -1;
#line 414 "Writer.c"
	} else {
#line 56 "../src/common/PAM/Writer.vala"
		_tmp12_ = FALSE;
#line 418 "Writer.c"
	}
#line 56 "../src/common/PAM/Writer.vala"
	if (_tmp12_) {
#line 422 "Writer.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 57 "../src/common/PAM/Writer.vala"
		_tmp13_ = contents;
#line 57 "../src/common/PAM/Writer.vala"
		_tmp14_ = string_splice (_tmp13_, (glong) (start_idx - 1), (glong) end_idx, NULL);
#line 57 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 57 "../src/common/PAM/Writer.vala"
		contents = _tmp14_;
#line 433 "Writer.c"
	}
#line 60 "../src/common/PAM/Writer.vala"
	_tmp15_ = g_string_new (PC_CONSTANTS_PAM_CONF_START);
#line 60 "../src/common/PAM/Writer.vala"
	builder = _tmp15_;
#line 61 "../src/common/PAM/Writer.vala"
	_tmp16_ = builder;
#line 61 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp16_, "\n");
#line 63 "../src/common/PAM/Writer.vala"
	_tmp17_ = config;
#line 63 "../src/common/PAM/Writer.vala"
	_tmp18_ = pc_pam_token_parse (_tmp17_);
#line 447 "Writer.c"
	{
		GList* token_collection = NULL;
		GList* token_it = NULL;
#line 63 "../src/common/PAM/Writer.vala"
		token_collection = _tmp18_;
#line 63 "../src/common/PAM/Writer.vala"
		for (token_it = token_collection; token_it != NULL; token_it = token_it->next) {
#line 455 "Writer.c"
			PCPAMToken* _tmp19_;
			PCPAMToken* token = NULL;
#line 63 "../src/common/PAM/Writer.vala"
			_tmp19_ = _g_object_ref0 ((PCPAMToken*) token_it->data);
#line 63 "../src/common/PAM/Writer.vala"
			token = _tmp19_;
#line 462 "Writer.c"
			{
				PCPAMToken* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				gboolean _tmp24_;
				GString* _tmp25_;
				PCPAMToken* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				GString* _tmp29_;
#line 64 "../src/common/PAM/Writer.vala"
				_tmp20_ = token;
#line 64 "../src/common/PAM/Writer.vala"
				_tmp21_ = pc_pam_token_get_user_arg0 (_tmp20_);
#line 64 "../src/common/PAM/Writer.vala"
				_tmp22_ = _tmp21_;
#line 64 "../src/common/PAM/Writer.vala"
				_tmp23_ = clean_username;
#line 64 "../src/common/PAM/Writer.vala"
				_tmp24_ = g_strcmp0 (_tmp22_, _tmp23_) == 0;
#line 64 "../src/common/PAM/Writer.vala"
				_g_free0 (_tmp22_);
#line 64 "../src/common/PAM/Writer.vala"
				if (_tmp24_) {
#line 65 "../src/common/PAM/Writer.vala"
					_g_object_unref0 (token);
#line 65 "../src/common/PAM/Writer.vala"
					continue;
#line 492 "Writer.c"
				}
#line 68 "../src/common/PAM/Writer.vala"
				_tmp25_ = builder;
#line 68 "../src/common/PAM/Writer.vala"
				_tmp26_ = token;
#line 68 "../src/common/PAM/Writer.vala"
				_tmp27_ = pc_pam_token_to_string (_tmp26_);
#line 68 "../src/common/PAM/Writer.vala"
				_tmp28_ = _tmp27_;
#line 68 "../src/common/PAM/Writer.vala"
				g_string_append (_tmp25_, _tmp28_);
#line 68 "../src/common/PAM/Writer.vala"
				_g_free0 (_tmp28_);
#line 69 "../src/common/PAM/Writer.vala"
				_tmp29_ = builder;
#line 69 "../src/common/PAM/Writer.vala"
				g_string_append (_tmp29_, "\n");
#line 63 "../src/common/PAM/Writer.vala"
				_g_object_unref0 (token);
#line 512 "Writer.c"
			}
		}
#line 63 "../src/common/PAM/Writer.vala"
		(token_collection == NULL) ? NULL : (token_collection = (_g_list_free__g_object_unref0_ (token_collection), NULL));
#line 517 "Writer.c"
	}
#line 72 "../src/common/PAM/Writer.vala"
	_tmp30_ = builder;
#line 72 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp30_, input);
#line 73 "../src/common/PAM/Writer.vala"
	_tmp31_ = builder;
#line 73 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp31_, "\n");
#line 74 "../src/common/PAM/Writer.vala"
	_tmp32_ = builder;
#line 74 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp32_, PC_CONSTANTS_PAM_CONF_END);
#line 531 "Writer.c"
	{
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		GString* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 77 "../src/common/PAM/Writer.vala"
		_tmp33_ = self->priv->filename;
#line 77 "../src/common/PAM/Writer.vala"
		_tmp34_ = contents;
#line 77 "../src/common/PAM/Writer.vala"
		_tmp35_ = builder;
#line 77 "../src/common/PAM/Writer.vala"
		_tmp36_ = _tmp35_->str;
#line 77 "../src/common/PAM/Writer.vala"
		_tmp37_ = g_strdup_printf ("%s\n%s", _tmp34_, _tmp36_);
#line 77 "../src/common/PAM/Writer.vala"
		_tmp38_ = _tmp37_;
#line 77 "../src/common/PAM/Writer.vala"
		g_file_set_contents (_tmp33_, _tmp38_, (gssize) -1, &_inner_error0_);
#line 77 "../src/common/PAM/Writer.vala"
		_g_free0 (_tmp38_);
#line 77 "../src/common/PAM/Writer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/common/PAM/Writer.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 559 "Writer.c"
				goto __catch1_g_file_error;
			}
#line 77 "../src/common/PAM/Writer.vala"
			_g_string_free0 (builder);
#line 77 "../src/common/PAM/Writer.vala"
			_g_free0 (config);
#line 77 "../src/common/PAM/Writer.vala"
			_g_free0 (contents);
#line 77 "../src/common/PAM/Writer.vala"
			_g_free0 (clean_username);
#line 77 "../src/common/PAM/Writer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/common/PAM/Writer.vala"
			g_clear_error (&_inner_error0_);
#line 77 "../src/common/PAM/Writer.vala"
			return;
#line 576 "Writer.c"
		}
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 76 "../src/common/PAM/Writer.vala"
		e = _inner_error0_;
#line 76 "../src/common/PAM/Writer.vala"
		_inner_error0_ = NULL;
#line 79 "../src/common/PAM/Writer.vala"
		_tmp39_ = e;
#line 79 "../src/common/PAM/Writer.vala"
		_tmp40_ = _tmp39_->message;
#line 79 "../src/common/PAM/Writer.vala"
		g_warning ("Writer.vala:79: %s\n", _tmp40_);
#line 76 "../src/common/PAM/Writer.vala"
		_g_error_free0 (e);
#line 597 "Writer.c"
	}
	__finally1:
#line 76 "../src/common/PAM/Writer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/common/PAM/Writer.vala"
		_g_string_free0 (builder);
#line 76 "../src/common/PAM/Writer.vala"
		_g_free0 (config);
#line 76 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 76 "../src/common/PAM/Writer.vala"
		_g_free0 (clean_username);
#line 76 "../src/common/PAM/Writer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/common/PAM/Writer.vala"
		g_clear_error (&_inner_error0_);
#line 76 "../src/common/PAM/Writer.vala"
		return;
#line 616 "Writer.c"
	}
#line 35 "../src/common/PAM/Writer.vala"
	_g_string_free0 (builder);
#line 35 "../src/common/PAM/Writer.vala"
	_g_free0 (config);
#line 35 "../src/common/PAM/Writer.vala"
	_g_free0 (contents);
#line 35 "../src/common/PAM/Writer.vala"
	_g_free0 (clean_username);
#line 626 "Writer.c"
}

void
pc_pam_writer_remove_restriction_for_user (PCPAMWriter* self,
                                           const gchar* username)
{
	gchar* contents = NULL;
	gint start_idx = 0;
	gint end_idx = 0;
	gchar* config = NULL;
	const gchar* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GString* builder = NULL;
	GString* _tmp11_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	GList* _tmp14_;
	GString* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 83 "../src/common/PAM/Writer.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/common/PAM/Writer.vala"
	g_return_if_fail (username != NULL);
#line 653 "Writer.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
#line 86 "../src/common/PAM/Writer.vala"
		_tmp0_ = self->priv->filename;
#line 86 "../src/common/PAM/Writer.vala"
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 86 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 86 "../src/common/PAM/Writer.vala"
		contents = _tmp1_;
#line 86 "../src/common/PAM/Writer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/common/PAM/Writer.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 669 "Writer.c"
				goto __catch0_g_file_error;
			}
#line 86 "../src/common/PAM/Writer.vala"
			_g_free0 (contents);
#line 86 "../src/common/PAM/Writer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/common/PAM/Writer.vala"
			g_clear_error (&_inner_error0_);
#line 86 "../src/common/PAM/Writer.vala"
			return;
#line 680 "Writer.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 85 "../src/common/PAM/Writer.vala"
		e = _inner_error0_;
#line 85 "../src/common/PAM/Writer.vala"
		_inner_error0_ = NULL;
#line 88 "../src/common/PAM/Writer.vala"
		_tmp2_ = e;
#line 88 "../src/common/PAM/Writer.vala"
		_tmp3_ = _tmp2_->message;
#line 88 "../src/common/PAM/Writer.vala"
		g_warning ("Writer.vala:88: %s", _tmp3_);
#line 89 "../src/common/PAM/Writer.vala"
		_g_error_free0 (e);
#line 89 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 89 "../src/common/PAM/Writer.vala"
		return;
#line 705 "Writer.c"
	}
	__finally0:
#line 85 "../src/common/PAM/Writer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 85 "../src/common/PAM/Writer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/common/PAM/Writer.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/common/PAM/Writer.vala"
		return;
#line 718 "Writer.c"
	}
#line 94 "../src/common/PAM/Writer.vala"
	_tmp4_ = contents;
#line 94 "../src/common/PAM/Writer.vala"
	_tmp7_ = pc_pam_reader_get_config (_tmp4_, &_tmp5_, &_tmp6_);
#line 94 "../src/common/PAM/Writer.vala"
	start_idx = _tmp5_;
#line 94 "../src/common/PAM/Writer.vala"
	end_idx = _tmp6_;
#line 94 "../src/common/PAM/Writer.vala"
	config = _tmp7_;
#line 96 "../src/common/PAM/Writer.vala"
	if (start_idx != -1) {
#line 96 "../src/common/PAM/Writer.vala"
		_tmp8_ = end_idx != -1;
#line 734 "Writer.c"
	} else {
#line 96 "../src/common/PAM/Writer.vala"
		_tmp8_ = FALSE;
#line 738 "Writer.c"
	}
#line 96 "../src/common/PAM/Writer.vala"
	if (_tmp8_) {
#line 742 "Writer.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 97 "../src/common/PAM/Writer.vala"
		_tmp9_ = contents;
#line 97 "../src/common/PAM/Writer.vala"
		_tmp10_ = string_splice (_tmp9_, (glong) (start_idx - 1), (glong) end_idx, NULL);
#line 97 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 97 "../src/common/PAM/Writer.vala"
		contents = _tmp10_;
#line 753 "Writer.c"
	} else {
#line 99 "../src/common/PAM/Writer.vala"
		_g_free0 (config);
#line 99 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 99 "../src/common/PAM/Writer.vala"
		return;
#line 761 "Writer.c"
	}
#line 102 "../src/common/PAM/Writer.vala"
	_tmp11_ = g_string_new (PC_CONSTANTS_PAM_CONF_START);
#line 102 "../src/common/PAM/Writer.vala"
	builder = _tmp11_;
#line 103 "../src/common/PAM/Writer.vala"
	_tmp12_ = builder;
#line 103 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp12_, "\n");
#line 105 "../src/common/PAM/Writer.vala"
	_tmp13_ = config;
#line 105 "../src/common/PAM/Writer.vala"
	_tmp14_ = pc_pam_token_parse (_tmp13_);
#line 775 "Writer.c"
	{
		GList* token_collection = NULL;
		GList* token_it = NULL;
#line 105 "../src/common/PAM/Writer.vala"
		token_collection = _tmp14_;
#line 105 "../src/common/PAM/Writer.vala"
		for (token_it = token_collection; token_it != NULL; token_it = token_it->next) {
#line 783 "Writer.c"
			PCPAMToken* _tmp15_;
			PCPAMToken* token = NULL;
#line 105 "../src/common/PAM/Writer.vala"
			_tmp15_ = _g_object_ref0 ((PCPAMToken*) token_it->data);
#line 105 "../src/common/PAM/Writer.vala"
			token = _tmp15_;
#line 790 "Writer.c"
			{
				PCPAMToken* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gboolean _tmp19_;
				GString* _tmp20_;
				PCPAMToken* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				GString* _tmp24_;
#line 106 "../src/common/PAM/Writer.vala"
				_tmp16_ = token;
#line 106 "../src/common/PAM/Writer.vala"
				_tmp17_ = pc_pam_token_get_user_arg0 (_tmp16_);
#line 106 "../src/common/PAM/Writer.vala"
				_tmp18_ = _tmp17_;
#line 106 "../src/common/PAM/Writer.vala"
				_tmp19_ = g_strcmp0 (_tmp18_, username) == 0;
#line 106 "../src/common/PAM/Writer.vala"
				_g_free0 (_tmp18_);
#line 106 "../src/common/PAM/Writer.vala"
				if (_tmp19_) {
#line 107 "../src/common/PAM/Writer.vala"
					_g_object_unref0 (token);
#line 107 "../src/common/PAM/Writer.vala"
					continue;
#line 817 "Writer.c"
				}
#line 110 "../src/common/PAM/Writer.vala"
				_tmp20_ = builder;
#line 110 "../src/common/PAM/Writer.vala"
				_tmp21_ = token;
#line 110 "../src/common/PAM/Writer.vala"
				_tmp22_ = pc_pam_token_to_string (_tmp21_);
#line 110 "../src/common/PAM/Writer.vala"
				_tmp23_ = _tmp22_;
#line 110 "../src/common/PAM/Writer.vala"
				g_string_append (_tmp20_, _tmp23_);
#line 110 "../src/common/PAM/Writer.vala"
				_g_free0 (_tmp23_);
#line 111 "../src/common/PAM/Writer.vala"
				_tmp24_ = builder;
#line 111 "../src/common/PAM/Writer.vala"
				g_string_append (_tmp24_, "\n");
#line 105 "../src/common/PAM/Writer.vala"
				_g_object_unref0 (token);
#line 837 "Writer.c"
			}
		}
#line 105 "../src/common/PAM/Writer.vala"
		(token_collection == NULL) ? NULL : (token_collection = (_g_list_free__g_object_unref0_ (token_collection), NULL));
#line 842 "Writer.c"
	}
#line 114 "../src/common/PAM/Writer.vala"
	_tmp25_ = builder;
#line 114 "../src/common/PAM/Writer.vala"
	g_string_append (_tmp25_, PC_CONSTANTS_PAM_CONF_END);
#line 848 "Writer.c"
	{
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		GString* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 117 "../src/common/PAM/Writer.vala"
		_tmp26_ = self->priv->filename;
#line 117 "../src/common/PAM/Writer.vala"
		_tmp27_ = contents;
#line 117 "../src/common/PAM/Writer.vala"
		_tmp28_ = builder;
#line 117 "../src/common/PAM/Writer.vala"
		_tmp29_ = _tmp28_->str;
#line 117 "../src/common/PAM/Writer.vala"
		_tmp30_ = g_strdup_printf ("%s\n%s", _tmp27_, _tmp29_);
#line 117 "../src/common/PAM/Writer.vala"
		_tmp31_ = _tmp30_;
#line 117 "../src/common/PAM/Writer.vala"
		g_file_set_contents (_tmp26_, _tmp31_, (gssize) -1, &_inner_error0_);
#line 117 "../src/common/PAM/Writer.vala"
		_g_free0 (_tmp31_);
#line 117 "../src/common/PAM/Writer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/common/PAM/Writer.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 876 "Writer.c"
				goto __catch1_g_file_error;
			}
#line 117 "../src/common/PAM/Writer.vala"
			_g_string_free0 (builder);
#line 117 "../src/common/PAM/Writer.vala"
			_g_free0 (config);
#line 117 "../src/common/PAM/Writer.vala"
			_g_free0 (contents);
#line 117 "../src/common/PAM/Writer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/common/PAM/Writer.vala"
			g_clear_error (&_inner_error0_);
#line 117 "../src/common/PAM/Writer.vala"
			return;
#line 891 "Writer.c"
		}
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
#line 116 "../src/common/PAM/Writer.vala"
		e = _inner_error0_;
#line 116 "../src/common/PAM/Writer.vala"
		_inner_error0_ = NULL;
#line 119 "../src/common/PAM/Writer.vala"
		_tmp32_ = e;
#line 119 "../src/common/PAM/Writer.vala"
		_tmp33_ = _tmp32_->message;
#line 119 "../src/common/PAM/Writer.vala"
		g_warning ("Writer.vala:119: %s\n", _tmp33_);
#line 116 "../src/common/PAM/Writer.vala"
		_g_error_free0 (e);
#line 912 "Writer.c"
	}
	__finally1:
#line 116 "../src/common/PAM/Writer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/common/PAM/Writer.vala"
		_g_string_free0 (builder);
#line 116 "../src/common/PAM/Writer.vala"
		_g_free0 (config);
#line 116 "../src/common/PAM/Writer.vala"
		_g_free0 (contents);
#line 116 "../src/common/PAM/Writer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/common/PAM/Writer.vala"
		g_clear_error (&_inner_error0_);
#line 116 "../src/common/PAM/Writer.vala"
		return;
#line 929 "Writer.c"
	}
#line 83 "../src/common/PAM/Writer.vala"
	_g_string_free0 (builder);
#line 83 "../src/common/PAM/Writer.vala"
	_g_free0 (config);
#line 83 "../src/common/PAM/Writer.vala"
	_g_free0 (contents);
#line 937 "Writer.c"
}

static void
pc_pam_writer_class_init (PCPAMWriterClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/common/PAM/Writer.vala"
	pc_pam_writer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/common/PAM/Writer.vala"
	g_type_class_adjust_private_offset (klass, &PCPAMWriter_private_offset);
#line 24 "../src/common/PAM/Writer.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_pam_writer_finalize;
#line 950 "Writer.c"
}

static void
pc_pam_writer_instance_init (PCPAMWriter * self,
                             gpointer klass)
{
#line 24 "../src/common/PAM/Writer.vala"
	self->priv = pc_pam_writer_get_instance_private (self);
#line 959 "Writer.c"
}

static void
pc_pam_writer_finalize (GObject * obj)
{
	PCPAMWriter * self;
#line 24 "../src/common/PAM/Writer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_PAM_TYPE_WRITER, PCPAMWriter);
#line 25 "../src/common/PAM/Writer.vala"
	_g_free0 (self->priv->filename);
#line 24 "../src/common/PAM/Writer.vala"
	G_OBJECT_CLASS (pc_pam_writer_parent_class)->finalize (obj);
#line 972 "Writer.c"
}

static GType
pc_pam_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCPAMWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_pam_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCPAMWriter), 0, (GInstanceInitFunc) pc_pam_writer_instance_init, NULL };
	GType pc_pam_writer_type_id;
	pc_pam_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "PCPAMWriter", &g_define_type_info, 0);
	PCPAMWriter_private_offset = g_type_add_instance_private (pc_pam_writer_type_id, sizeof (PCPAMWriterPrivate));
	return pc_pam_writer_type_id;
}

GType
pc_pam_writer_get_type (void)
{
	static volatile gsize pc_pam_writer_type_id__once = 0;
	if (g_once_init_enter (&pc_pam_writer_type_id__once)) {
		GType pc_pam_writer_type_id;
		pc_pam_writer_type_id = pc_pam_writer_get_type_once ();
		g_once_init_leave (&pc_pam_writer_type_id__once, pc_pam_writer_type_id);
	}
	return pc_pam_writer_type_id__once;
}

